Package: ChIPseqR
Type: Package
Title: Identifying Protein Binding Sites in High-Throughput Sequencing
        Data
Version: 1.67.0
Date: 2015-12-17
Author: Peter Humburg
Maintainer: Peter Humburg <peter.humburg@gmail.com>
Depends: R (>= 2.10.0), methods, BiocGenerics, S4Vectors (>= 0.9.25)
Imports: Biostrings, fBasics, GenomicRanges, IRanges (>= 2.5.14),
        graphics, grDevices, HilbertVis, ShortRead, stats, timsac,
        utils
Description: ChIPseqR identifies protein binding sites from ChIP-seq
        and nucleosome positioning experiments. The model used to
        describe binding events was developed to locate nucleosomes but
        should flexible enough to handle other types of experiments as
        well.
License: GPL (>= 2)
LazyLoad: yes
Collate: classes.R generics.R initialize.R methods.R access.R package.R
biocViews: ChIPSeq, Infrastructure
git_url: https://git.bioconductor.org/packages/ChIPseqR
git_branch: devel
git_last_commit: 2ef23a4
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-28 21:50:21 UTC; biocbuild

![](http://bioconductor.org/shields/availability/devel/ChIPseqR.svg)
![](http://bioconductor.org/shields/build/devel/bioc/ChIPseqR.svg)
![](http://bioconductor.org/shields/years-in-bioc/ChIPseqR.svg)
![](http://bioconductor.org/shields/downloads/ChIPseqR.svg)

# ChIPseqR
ChIPseqR identifies protein binding sites from ChIP-seq and nucleosome positioning experiments. 
The model used to describe binding events was developed to locate nucleosomes but should flexible enough to 
handle other types of experiments as well.

# Installation
Both the [development](http://bioconductor.org/packages/devel/bioc/html/ChIPseqR.html) and 
[release](http://bioconductor.org/packages/release/bioc/html/ChIPseqR.html) version of this R package
are available through [Bioconductor](http://bioconductor.org/). Use the *BiocManager* to install the
package and its dependencies from within R.

```r
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("ChIPseqR")
```

# Access and replacement functions for S4 classes
# 
# Author: Peter Humburg
###############################################################################

############################### ReadCounts ####################################

## access
setMethod("[[", c(x="ReadCounts", j="missing"),
		function(x, i, exact=TRUE){
			x@counts[[i, exact=exact]]
		}
)

setMethod("[", c(x="ReadCounts", j="missing", drop="missing"),
		function(x, i){
			x@counts[i]
		}
)

setMethod("$", "ReadCounts",
		function(x, name){
			x@counts[[name, exact=FALSE]]
		}
)

setMethod("names", "ReadCounts",
		function(x){
			names(x@counts)
		}
)

## replacement
setMethod("[[<-", c(x="ReadCounts", j="missing"),
		function(x, i, exact=TRUE, value){
			## ensure that value is an integer matrix
			if(!is.matrix(value) || !is.integer(value) || !(ncol(value) == 2)){
				value <- matrix(as.integer(value), ncol=2)
			}
			colnames(value) <- c("+", "-")
			x@counts[[i, exact=exact]] <- value
			
			invisible(x)
		}
)

setMethod("[<-", c(x="ReadCounts", j="missing"),
		function(x, i, exact=TRUE, value){
			for(j in 1:length(i))
				x[[i[[j]], exact=exact]] <- value[[j]]
			
			invisible(x)
		}
)

setMethod("$<-", "ReadCounts",
		function(x, name, value){
			x[[name, exact=FALSE]] <- value
			invisible(x)
		}
)

setMethod("names<-", "ReadCounts", function(x, value){names(x@counts) <- value; invisible(x)})

############################### BindScore ####################################
## subset results to restrict them to individual chromosomes
setMethod("[[", c(x="BindScore", j="missing"),
		function(x, i, exact=TRUE) x[i]
)
## subset results to restrict them to a subset of an individual chromosome
setMethod("[[", c(x="BindScore", j="numeric"),
		function(x, i, j, exact=TRUE){
			if(is.character(i)) names <- i
			else names <- names(x)[i]
			peaks <- peaks(x)[[i]][peaks(x)[[i]] <= max(j) & peaks(x)[[i]] >= min(j)]
			offset <- x@start
			j <- j - offset + 1
			if(max(j) <= 0) j <- numeric()
			else j[which.min(j)] <- max(min(j), 1)
			j <- j[j > 0]
			scores <- if(length(j) > 0) list(as.numeric(window(score(x)[[i]],min(j),max(j)))) 
					else list(new(class(score(x)[[i]])))
			pvalues <- if(length(j) > 0) list(as.numeric(window(pvalue(x)[[i]],min(j),max(j)))) 
					else list(new(class(pvalue(x)[[i]])))
			new(class(x), x@functionCall, scores, pvalues, list(peaks), cutoff=cutoff(x), 
					nullDist=nullDist(x), names=names, start=min(j)+offset - 1)
		}
)

## subset results by chromosome
setMethod("[", c(x="BindScore", j="missing", drop="missing"),
		function(x, i){
			if(is.character(i)) names <- i
			else names <- names(x)[i]
			new(class(x), x@functionCall, score(x)[i], pvalue(x)[i], peaks(x)[i], 
					cutoff=cutoff(x), nullDist=nullDist(x), names=names)
		}
)

setMethod("names", "BindScore", function(x) names(x@score))

setMethod("names<-", "BindScore", function(x, value){
			names(x@score) <- value
			names(x@pvalue) <- value
			names(x@peaks) <- value
			invisible(x)
		}
)

## access slots
setMethod("score", "BindScore", function(x) x@score)
setMethod("cutoff", "BindScore", 
		function(x, type=c("score", "pvalue")){
			select <- pmatch(type, c("score", "pvalue"), nomatch=0)
			if(all(sapply(select, ">", 0)))
				return(x@cutoff[select])
			else return(NULL)
		}
)
setMethod("cutoff<-", "BindScore",
		function(x, type=c("score", "pvalue"), value){
			select <- pmatch(type, c("score", "pvalue"), nomatch=0)
			if(length(select) != 1 || select == 0)
				stop("Argument 'type' has to be either \"score\" or \"pvalue\".")
			
			if(select == 1){
				newScore <- value
				## find matching p-value. We don't have information about null distribution anymore, 
				## infer from data instead
				chrMin <- sapply(score(x), function(y) min(y[y >= value], na.rm=TRUE))
				chr <- which.min(chrMin)
				pv.idx <- which(score(x)[[chr]] == chrMin[chr])[1]
				newPvalue <- pvalue(x)[[chr]][pv.idx]
			}
			else if(select == 2){
				newPvalue <- value
				## find matching score
				chrMax <- sapply(pvalue(x), function(y) max(y[y <= value], na.rm=TRUE))
				chr <- which.max(chrMax)
				score.idx <- which(pvalue(x)[[chr]] == chrMax[chr])[1]
				newScore <- score(x)[[chr]][score.idx]
			}
			
			x@cutoff[1:2] <- c(newScore, newPvalue)
			x@peaks <- lapply(score(x), pickPeak, newScore, offset=support(x) + ceiling(binding(x)/2))
			
			invisible(x)
		}
)
setMethod("nullDist<-", "BindScore",
		function(x, value){
			## check new value
			stopifnot(length(value) == 2)
			x@nullDist[1:2] <- value
			
			## re-evaluate p-values
			x@pvalue <- .score2pval(score(x), nullDist(x))
			
			## update score cut-off and significant peaks
			cutoff(x, type="pvalue") <- cutoff(x, type="pvalue")
			
			invisible(x)
		}
)

## extract parameter values from function call
setMethod("binding", "BindScore", function(x) x@functionCall$bind)
setMethod("support", "BindScore", function(x) x@functionCall$support)

# New method implementations for generic functions
# 
# Author: Peter Humburg
###############################################################################

####################### methods for strandPileup ##############################
## strand specific read counts from 'AlignedRead'
setMethod("strandPileup", "AlignedRead",
		definition=function(aligned, chrLen, extend, coords=c("leftmost", "fiveprime"), 
				compress=TRUE, plot=TRUE, ask=FALSE, ...){
			
			coords <- match.arg(coords)
			chrFilter <- lapply(levels(chromosome(aligned)), function(chr, all) all == chr, chromosome(aligned))
			
			## compute pileup for each chromosome
			counts <- mapply(function(filter, len, extend, aligned, ...){ 
						sfilter1 <- filter & strand(aligned) == "+"
						sfilter2 <- filter & strand(aligned) == "-"
						## separate strands
						fwd <- aligned[sfilter1]
						rev <- aligned[sfilter2] 
						ext1 <- -width(fwd) + as.integer(extend)
						ext2 <- -width(rev) + as.integer(extend)
						counts <- list(coverage(fwd, extend = ext1, coords = coords, ...)[[1]],
								coverage(rev, extend = ext2, coords = coords, ...)[[1]])
						## append trailing zeros to get full chromosome length
						counts <- .fixCounts(counts, len)
						
						if(!compress) counts <- decompress(counts)
						counts
					},  
					chrFilter, chrLen, extend, MoreArgs=c(list(aligned=aligned), list(...)), SIMPLIFY=FALSE)
			
			counts <- ReadCounts(counts, levels(chromosome(aligned)), compress=compress)
			if(!plot) return(counts)
			
			## plot image of counts for each chromosome and strand 
			ask <- devAskNewPage(ask)
			for(i in 1:length(counts)){
				plot(counts, chr=i, type="hilbert", scale="ratio", log=TRUE)
				plot(counts, chr=i, type="hilbert", scale="total", log=TRUE)
			}
			devAskNewPage(ask)
			
			invisible(counts)
		}
)

## strand specific read counts from data frame
setMethod("strandPileup", "data.frame",
		definition=function(aligned, chrLen, extend, coords=c("leftmost", "fiveprime"), 
				compress=TRUE, plot=TRUE, ask=FALSE, ...){
			
			coords <- match.arg(coords)
			## ensure aligned contains all required information
			## Note that all operations are based on column names. This allows
			## for the presence of additional columns and arbitrary column order
			## but imposes strict requirements on column names.
			requiredNames <- c("chromosome", "start", "end", "strand")
			
			## Chromosome names should be stored as factor
			if(!"chromosome" %in% names(aligned)) {
			  stop("Chromosome names are missing.")
			}
			if(!is.factor(aligned[["chromosome"]])) {
			  aligned[["chromosome"]] <- as.factor(aligned[["chromosome"]])
			}
			
			## need names for chrLen
			if(is.null(names(chrLen))) names(chrLen) <- levels(aligned$chromosome)
			
			## if we have start position and length for each read we convert this
			## into start and end position
			if(all(c("position", "length") %in% names(aligned)) && !isTRUE("start" %in% names(aligned)))
				names(aligned)[which(names(aligned) == "position")] <- "start"
			## ensure 'start' is 5'-end and 'end' is 3'-end
			if(all(c("start", "length") %in% names(aligned)) && !isTRUE("end" %in% names(aligned))){
				idx <- aligned$strand == "+"
				if(coords == "leftmost") {
					aligned$end <- aligned$start + aligned$length - 1
					tmp <- aligned$start[!idx]
					aligned$start[!idx] <- aligned$end[!idx]
					aligned$end[!idx] <- tmp
				}
				if(coords == "fiveprime"){
					aligned$end <- integer(nrow(aligned))
					aligned$end[idx] <- aligned$start[idx] + aligned$length[idx] - 1
					aligned$end[!idx] <- aligned$start[!idx] - aligned$length[!idx] + 1
				}		
			}
			if(!all(requiredNames %in% names(aligned)))
				stop("Columns ", requiredNames[which(!(requiredNames %in% names(aligned)))], " are missing.")
			
			## compute pileup for each chromosome
			counts <- vector(length(levels(aligned$chromosome)), mode="list")
			names(counts) <- levels(aligned$chromosome)
			for(chr in levels(aligned$chromosome)){
				chrFilter <- aligned$chromosome == chr
				strFilter <- aligned$strand == "+"
				start1 <- aligned$start[chrFilter & strFilter]
				start1 <- start1[start1 + extend -1 <= chrLen[chr]]
				start2 <- aligned$end[chrFilter & !strFilter] - extend + 1
				start2 <- start2[start2 >= 1L]
				
				counts[[chr]] <- list(coverage(IRanges::IRanges(start=start1, width=extend), ...), 
						coverage(IRanges::IRanges(start=start2, width=extend), ...))
				counts[[chr]] <- .fixCounts(counts[[chr]], chrLen[chr])
				if(!compress) counts[[chr]] <- decompress(counts[[chr]])
			}
			counts <- ReadCounts(counts, compress=compress)
			if(!plot) return(counts)
			
			## plot image of counts for each chromosome and strand
			ask <- devAskNewPage(ask)
			for(i in 1:length(counts)){
				plot(counts, chr=i, type="hilbert", scale="ratio", log=TRUE)
				plot(counts, chr=i, type="hilbert", scale="total", log=TRUE)
			}
			devAskNewPage(ask)
			
			invisible(counts)
		}
)


####################### methods for callBindingSites ##############################

## binding sites from list of read counts (one component per chromosome) 
## this is where the actual work is done, other methods should create strand specific 
## read counts and pass them on to this method
setMethod("callBindingSites", "ReadCounts", 
		definition=function(data, bind, support, background, bgCutoff=0.9, supCutoff=0.9, 
				fdr = 0.05, extend=1, tailCut=0.95, piLambda=0.5, adapt=FALSE, corSummary=median, 
				compress=TRUE, digits=16, plot=TRUE, verbose=TRUE, ask=FALSE, plotTo, ...){
			
			if(missing(bind))
				stop("Mandatory argument \"bind\" is missing. Please specify length of binding region. ",
						"You may specify a range of possible values by providing the minimum and maximum.")
			if(missing(support))
				stop("Mandatory argument \"support\" is missing. Please specify length of support region. ",
						"You may specify a range of possible values by providing the minimum and maximum.")
			
			
			## plot to file plotTo
			if(!missing(plotTo) && plot) pdf(plotTo, width=8, height=11)
						
			## determine length of binding and support region if necessary
			if(length(bind) > 1 || length(support) > 1){
				if(verbose) message("Determining length of binding and support region...")
				if(plot) par(mfrow=c(2,1))
				regionLen <- getBindLen(data, bind, support, corSummary, verbose=verbose, plot=plot)
				bind <- regionLen[1]
				support <- regionLen[2]
			}
			
			## ensure 'background' has sensible value
			if(missing(background)){
				background <- 10*(bind + 2*support)
				if(verbose) message("Setting length of background window to ", background, ".")
			}
			if(background < 2*(bind + 2*support)){
				warning("Background window is too short (", background, "). Using", 10*(bind + 2*support), "instead.\n")
				background <- 10*(bind + 2*support)
			}
			
			## calculate score
			if(verbose) message("Scoring binding sites...")
			score <- lapply(data, startScore, b=bind, support=support, background=background, bgCutoff=bgCutoff, 
					supCutoff=supCutoff)
			
			## identify significant peaks
			if(verbose) message("Determining significance...")
			allScores <- c(lapply(score, function(x) x[!is.na(x)]), recursive=TRUE)
			cutoff <- getCutoff(allScores, alpha = fdr, lambda = piLambda, tailCut=tailCut, adapt=adapt, plot = plot, 
					returnPval=TRUE)
			if(verbose) message("Significance threshold [score (p-value)]: ", sprintf("%.2f", cutoff$cutoff[1]), " (", 
						cutoff$cutoff[2], ")")
			rm(allScores)
			peaks <- lapply(score, pickPeak, cutoff$cutoff[1], offset=support + ceiling(bind/2))
			
			
			## need to map p-values back to genomic coordinates
			at <- lapply(score, is.na)
			pval <- vector(length(score), mode="list")
			start <- 0
			for(i in 1:length(score)){
				pval[[i]] <- numeric(length(score)) + NA
				pval[[i]][which(!at[[i]])] <- cutoff$pvalue[1:sum(!at[[i]])+start]
				start <- start + sum(!at[[i]])
			}
			
			call <- match.call(callBindingSites, call=sys.call(sys.parent()))
			call$bind <- eval(call$bind)
			call$support <- eval(call$support)
			call$background <- eval(call$background)
			start <- support + ceiling(bind/2)
			result <- BindScore(call=call, score=score, pvalue=pval, peaks=peaks, cutoff=cutoff$cutoff, 
					nullDist=cutoff$h0, names=names(data), compress=compress, digits=digits, start=start)
			
			if(plot){
				par(mfrow=c(1, 2))
				plot(result, type="density")
				plot(result, type="qqplot")
			}
			if(!missing(plotTo) && plot) dev.off()
			
			result
		}
)

## using matrix of read counts (single chromosome)
setMethod("callBindingSites", "matrix",
		definition=function(data, chrName="chr", ...){
			data <- new("ReadCounts", list(data), chrName)
			call <- match.call(callBindingSites,sys.call())
			call$data <- data
			call[[1]] <- `callBindingSites`
			for(i in 3:length(call)) call[[i]] <- eval(call[[i]])
			eval(call)
		}
)

## using name of file with mapped reads
## type: file type (see ?readAligned for details)
## minQual: minimum alignment quality to use. All reads with lower alignment quality will be removed 
##          before pilup is created
setMethod("callBindingSites", "character",
		definition=function(data, type, minQual=70, ...){
			data <- readAligned(data, type=type)
			data <- data[quality(alignQuality(data)) >= minQual]
			
			call <- match.call(callBindingSites,sys.call())
			call$data <- data
			call[[1]] <- `callBindingSites`
			for(i in 3:length(call)) call[[i]] <- eval(call[[i]])
			eval(call)			
		})


## For everything else we try to compute read counts and pass data on to the list method
setMethod("callBindingSites", "ANY",
		definition=function(data, chrLen, plot=TRUE, verbose=TRUE, ..., plotTo){
			## plot to file plotTo
			if(!missing(plotTo) && plot) {
				pdf(plotTo, width=8, height=11)
				par(mfrow=c(length(chrLen), 2))
			}
			if(verbose) message("Accumulating read counts...")
			
			dots <- list(...)
			if(is.null(dots$extend)) dots$extend <- 1			 
			counts <- strandPileup(data, chrLen=chrLen, extend=dots$extend, plot=plot)
			
			call <- match.call(callBindingSites,sys.call())
			call$data <- counts
			call[[1]] <- `callBindingSites`
			for(i in 3:length(call)) call[[i]] <- eval(call[[i]])
			bindScore <- eval(call)
			
			if(!missing(plotTo) && plot) dev.off()
			
			return(bindScore)
		}
)

############################# New methods for existing generic functions ##############################

## lapply method for ReadCounts objects
setMethod("lapply", "ReadCounts",
		definition=function(X, FUN, ...){
			lapply(X@counts, FUN, ...)
		}
)

## sapply method for ReadCounts objects
setMethod("sapply", "ReadCounts",
		definition=function(X, FUN, ..., simplify = TRUE, USE.NAMES = TRUE){
			sapply(X@counts, FUN, ..., simplify = simplify, USE.NAMES = USE.NAMES)
		}
)

## lapply for BindScore objects. Applies function by chromosome
setMethod("lapply", "BindScore",
		definition=function(X, FUN, ...){
			result <- vector(length(names(X)), mode="list")
			names(result) <- names(X)
			for(i in names(X)){
				result[[i]] <- match.fun(FUN)(X[[i]], ...)
			}
			result
		}
)


## number of chromosomes
setMethod("length", "ReadCounts", definition=function(x) length(x@counts))

## length of chromosomes
setMethod("chrLength", "ReadCounts", definition=function(x, subset){
			len <- sapply(x, nrow)
			if(!missing(subset)) len <- len[subset]
			len
		} 
)

setMethod("chrLength", "RLEReadCounts", definition=function(x, subset){
			len <- sapply(x, S4Vectors::elementNROWS)[1, ]
			if(!missing(subset)) len <- len[subset]
			len
		} 
)

setMethod("chrLength", "BindScore", definition=function(x, subset){
			len <- S4Vectors::elementNROWS(score(x)) + 2*support(x) + binding(x)
			if(!missing(subset)) len <- len[subset]
			len
		} 
)

## number of reads on each chromosome/strand
setMethod("nreads", "ReadCounts", definition=function(x, byStrand = TRUE, subset){
			if(byStrand){ 
				counts <- sapply(x, colSums)
				if(!missing(subset)) counts <- matrix(counts[ , subset], nrow = 2, 
							dimnames=list(c("+", "-"), colnames(counts)[subset]))
			} else{ 
				counts <- sapply(x, sum)
				if(!missing(subset)) counts <- counts[subset]
			}
			counts
		}
)

setMethod("nreads", "RLEReadCounts", definition=function(x, byStrand = TRUE, subset){
			counts <- sapply(x, sum)
			if(!missing(subset))
				counts <- matrix(counts[ , subset], nrow = 2, dimnames=list(c("+", "-"), 
								colnames(counts)[subset]))
			if(!byStrand) counts <- colSums(counts)
			counts
		}
)


## number of predicted binding sites
setMethod("length", "BindScore", definition=function(x) sum(sapply(peaks(x), length)))

setMethod("length<-", "ReadCounts",
		definition=function(x, value){length(x@counts) <- value; invisible(x)})

## TODO: this is inconsistent with the length method above, consider changing
setMethod("length<-", "BindScore", 
		definition=function(x, value){
			length(x@score) <- value
			length(x@pvalue) <- value
			length(x@peaks) <- value
			invisible(x)
		}
)

## convert to data.frame
setMethod("as.data.frame", c(x="BindScore"),
		definition=function(x, ...){
			chr <- rep(names(x), times=S4Vectors::elementNROWS(peaks(x)))
			pos <- c(peaks(x), recursive=TRUE)
			peakScores <- c(mapply(function(y, i, offset) as.numeric(y[i - offset]),  score(x), peaks(x), 
							MoreArgs=list(support(x) + ceiling(binding(x)/2)), SIMPLIFY=FALSE), 
					recursive=TRUE)
			peakPval <- c(mapply(function(y, i, offset) as.numeric(y[i - offset]), pvalue(x), peaks(x), 
							MoreArgs=list(support(x) + ceiling(binding(x)/2)), SIMPLIFY=FALSE), 
					recursive=TRUE)
			
			df <- data.frame(chromosome=chr, position=pos, score=peakScores, pvalue=peakPval, stringsAsFactors = TRUE)
			if(nrow(df) > 0) rownames(df) <- 1:nrow(df)
			
			df
		}
)


## get first n peaks (either by position or score)
setMethod("head", "BindScore", 
		definition=function(x, n=6, by=c("score", "position"), ...){

			df <- as.data.frame(x)
			
			type <- pmatch(by[1], c("score", "position"), nomatch=0)
			if(type == 1){
				idx <- order(df$pvalue, -df$score)
				df <- df[idx,]
			} 
			
			head(df, n, ...)
		}
)

## get last n peaks (either by position or score)
setMethod("tail", "BindScore", 
		definition=function(x, n=6, by=c("score", "position"), ...){
			
			df <- as.data.frame(x)
			
			type <- pmatch(by[1], c("score", "position"), nomatch=0)
			if(type == 1){
				idx <- order(df$pvalue, -df$score)
				df <- df[idx,]
			} 
			
			tail(df, n, ...)
		}
)

## minimum and maximum score
setMethod("min", "BindScore",
		definition=function(x, ..., na.rm=TRUE){
			min(sapply(score(x), min, na.rm=na.rm))
		}
)

setMethod("max", "BindScore",
		definition=function(x, ..., na.rm=TRUE){
			max(sapply(score(x), max, na.rm=na.rm))
		}
)

setMethod("range", "BindScore",
		definition=function(x, ..., na.rm=TRUE){
			c(min(x, na.rm=na.rm), max(x, na.rm=na.rm))
		}
)

## human readable summaries
setMethod("show", "ReadCounts", 
		definition=function(object){
			.showHeader(object)
			cat("Number of reads:", sum(sapply(object@counts, sum)),"\n")			
		}
)

setMethod("show", "BindScore", 
		definition=function(object){
			.showHeader(object)
			cat("Predicted binding sites:", length(object), "\n")
			cat("Significance cut-off: ", cutoff(object, "score"), 
					" (p-value: ", cutoff(object, "pvalue"), ")\n", sep = "")
		}
)

## explicit conversion between compressed and decompressed representations
setMethod("compress", "ReadCounts",
		definition=function(x){
			ReadCounts(counts=x@counts, compress=TRUE)
		}
)
setMethod("compress", "BindScore",
		definition=function(x, digits=16){
			BindScore(call=x@functionCall, score=score(x), pvalue=pvalue(x), peaks=peaks(x),
					cutoff=cutoff(x), nullDist=nullDist(x), compress=TRUE, digits=digits)
		}
)
setMethod("compress", "RLEReadCounts",
		definition=function(x){ ## input is already compressed, do nothing
			x
		}
)
setMethod("compress", "RLEBindScore",
		definition=function(x){ ## input is already compressed, do nothing
			x
		}
)
setMethod("decompress", "RLEReadCounts", 
		definition=function(x){
			ReadCounts(counts=lapply(x@counts, decompress, simplify=TRUE), compress=FALSE)
		}
)
setMethod("decompress", "RLEBindScore", 
		definition=function(x){
			BindScore(call=x@functionCall, score=lapply(score(x), as.numeric), 
					pvalue=lapply(pvalue(x), as.numeric), peaks=peaks(x), cutoff=cutoff(x), 
					nullDist=nullDist(x),start=x@start, compress=FALSE)
		}
)

setMethod("decompress", "Rle",
		definition=function(x, class){
			if(missing(class)) class <- base::class(runValue(x))
			as(x, class)
		}
)
setMethod("decompress", "RleList",
		definition=function(x, class, simplify=TRUE){
			if(missing(class)) class <- sapply(x, function(i) base::class(runValue(i)))
			result <- lapply(1:length(x), function(i) as(x[[i]], class[i]))
			names(result) <- names(x)
			
			## simplify into matrix or vector if possible
			if(simplify & length(result) == 1) result <- result[[1]]
			else if(simplify & all.equal(class, rep(class[1], length(class)), check.attributes=FALSE) & 
					max(abs(diff(S4Vectors::elementNROWS(result)))) == 0){
				result <- do.call(cbind, result)
			}
			
			result
		}
)

#################  plotting functions ##########################

## plot read counts in a window, optionally with overlayed score and nucleosome positions
## or plot hilbert curve of all read counts on chromosome
setMethod("plot", list(x="ReadCounts", y="missing"), 
		definition=function(x, chr, center, score, width=2000, type=c("hilbert", "window"), ...){
			type <- match.arg(type)
			if(missing(chr) && length(x) == 1) chr <- names(x)
			if(type == "window"){
				if(!missing(score)){
					start <- center - ceiling(width/2)
					score <- decompress(score[[chr, start:(start + width+1)]])
				} 
				.plotWindow(x, chr=chr, center=center, score=score, width=width, ...)
			}
			else if(type == "hilbert") .plotReads(x[[chr]], ...)
		}
)

setMethod("plot", list(x="RLEReadCounts", y="missing"), 
		definition=function(x, chr, center, score,  width=2000, type=c("hilbert", "window"), ...){
			type <- match.arg(type)
			if(missing(chr) && length(x) == 1) chr <- names(x)
			if(type == "window"){
				start <- floor(center - ceiling(width/2))
				end <- ceiling(center + ceiling(width/2))
				if(!is.character(chr)) chr <- names(x)[chr]
				x <- list(sapply(x[[chr]], function(x) as.integer(window(x,start,end))))
				names(x) <- chr
				
				if(!missing(score)) score <- decompress(score[[chr, start:end]])
				.plotWindow(x, chr=chr, start=start, end=end, width=width, score=score, offset=start, ...)
			}
			else if(type == "hilbert"){
				.plotReads(decompress(x[[chr]]), ...)
			}
		}
)

## plots to asses fit of null distribution
setMethod("plot", list(x="BindScore", y="missing"),
		definition=function(x, npoints = 10000, type=c("density", "qqplot"), ...){
			type <- match.arg(type)
			
			cutoff <- cutoff(x)["score"]
			nullDist <- nullDist(x)
			## get vector of all scores
			values <- unlist(lapply(score(x), function(x) {d <- decompress(x); d[!is.na(d)]}),
					use.names=FALSE)
			if(type == "density"){
				minVal <- min(values)
				maxVal <- max(values)
				range <- maxVal - minVal
				breaks <- seq(minVal, maxVal, length.out=max(range, 100))
				hist(values, breaks=breaks, freq=FALSE, main="Empirical and fitted null distribution", xlab="Score")
				lines(seq(minVal, maxVal, by=0.1), dnorm(seq(minVal, maxVal, by=0.1),
								mean=nullDist["mean"], sd=nullDist["sd"]), col=2)
				if(is.finite(cutoff)) abline(v=cutoff, col=4, lty=2)
			}
			if(type == "qqplot"){
				## qqnorm is very slow for large samples
				## if the sample is large we just plot a subset of all points
				if(length(values) <= npoints){ 
					qqnorm(values)
					qqline(values, col=2)
				}
				else{
					qObs <- quantile(values, probs=seq(0,1, length.out=npoints))
					qTheo <- qnorm(ppoints(qObs))
					plot(qTheo, qObs, xlab="Theoretical Quantiles", ylab="Sample Quantiles", main="Normal Q-Q Plot")
					qqline(values, col=2)
				}
				if(is.finite(cutoff)) abline(h=cutoff, col=4, lty=2)
			}
		})

# Functions for ChIPseqR package
# 
# Author: Peter Humburg
###############################################################################


############## read mapping #######################

## align sequence data according to transcription start sites
## data: mapped reads (ReadCounts object)
## anno: gff formated annotations for genes (or any other feature of interest)
## offset: number of base pairs to use from either side of TSS
## returns a list of sequences centred around TSS
alignFeature <- function(data, anno, offset = 1000){
	align <- function(start,x,offset){
		
		chr <- as.character(start[1,1])
		pos <- as.numeric(start[1,2])
		
		if(is.null(x[[chr]])) return(NULL)
		
		## read counts may be compressed
		x <- decompress(x[[chr]])
		
		## may be dealing with pooled forward and reverse read counts
		if(!is.matrix(x)) x <- matrix(x, ncol=1)
		
		ret <- matrix(0,ncol=ncol(x),nrow=2*offset+1)
		slice <- (offset-min(pos,offset)+1):(offset+min(offset,nrow(x)-pos-1)+1)
		ret[slice,] <- x[(pos-(offset-slice[1]+1)):(pos+(slice[length(slice)]-offset-1)),]
		
		ret
	}
	seq.genes <- vector(nrow(anno), mode="list")
	
	for(i in 1:nrow(anno)){
		reverse <- anno[i,7]=="-"
		seq.genes[[i]] <- align(anno[i,c(1,4+reverse)], data, offset)
		if(reverse) seq.genes[[i]] <- rev(seq.genes[[i]])
	}
	
	
	seq.genes	
}

## compute sliding window summaries of read counts
windowCounts <- function(reads, window=1000, shift=500, method=sum){
    views <- slidingViews(reads, window, shift)
    wndw <- viewApply(views, function(v) method(as.vector(v)))
    names(wndw) <- mid(ranges(views))
    wndw
}


########### visualisation ####################


## plot read counts in a window, optionally with overlayed score and nucleosome positions
.plotWindow <- function(data, chr, center, score, width=2000, bind, start, end,
		bind.col=3, score.type='l',	xlab=NULL, ylab="Read count", cutoff=TRUE, offset=1, ...){
	stopifnot(is(data, "ReadCounts") || is.list(data))
	
	data <- data[[chr]]
	if(missing(start)) start <- floor(center - ceiling(width/2))
	if(missing(end)) end <- ceiling(center + ceiling(width/2))
	
	range <- start:end - offset + 1
	height <- max(data[range,])
	
	if(!missing(score)){
		mar <- par("mar")
		mar[4] <- max(4.1, mar[4])
		par(mar=mar)
		score <- score[[chr, start:end]]
		peaks <- unlist(peaks(score))
		if(missing(bind)) bind <- binding(score)
		support <- support(score)
		binding <- binding(score)
		cutValue <- cutoff(score)["score"]
		score <- unlist(score(score))
	}
	
	## plot read counts
	if(is.null(xlab)) xlab <- paste(chr, start, "-", end)
	plot(start:end, data[range,1], ylim=c(0,height), type='h', ylab=ylab, xlab=xlab, col=2, ...)
	lines(start:end, data[range,2], type='h', col=4, lty=2)
	
	## plot score
	if(!missing(score)){
		score.col <- col2rgb(3)/255
		score.col <- rgb(sqrt(score.col[1,]), sqrt(score.col[2,]), sqrt(score.col[3,]))
		
		min.score <- min(score, na.rm=TRUE)
		max.score <- max(score, na.rm=TRUE)
		denom <- ((max.score-min.score)/height)
		lines(start:end, (score - min.score)/denom, col=score.col, lty=1, type=score.type, cex=0.5)
		if(cutoff) abline(h=(cutValue - min.score)/denom, col=score.col, lty=2)
		
		## add axis
		ticks <- pretty(score)
		ticks.at <- height*(ticks - min.score)/(max.score-min.score)
		axis(4, labels=ticks, at=ticks.at, col=score.col, col.axis=score.col)
		mtext("Score", side=4, line=2.5, cex=par("cex")*par("cex.lab"), col=score.col)
		
		## plot predicted binding sites
		if(length(peaks) > 0)
			.plotBind(peaks, 0, col=bind.col, b=bind, bind=binding, offset=0, 
					step=-0.01*(par("usr")[4]-par("usr")[3]), lwd=4, lend=1, extend=support)
	}
	
}

## plot binding sites
## plots binding region (bind) of predicted binding site as well as actual (assumed) length of binding site (b) 
.plotBind <- function(x, y, col=1, add=TRUE, b=147, bind=128, offset=-1000, step, extend, ...){
	## assume bind <= b
	## TODO: May want to allow bind > b, not sure whether it is needed in practice though
	x.centre <- x
		
	## calculate vertical position of features to plot
	len <- max(b, bind + 2*extend) + 1
	ypos <- numeric(length(x)) + y
	if(length(x) > 1) for(i in 2:length(x)){
		if(x[i] <= x[i-1] + len) ypos[i] <- ypos[i-1] + step
	}
	
	x <- x.centre - ceiling(b/2)
	## plot larger feature first
	if(!identical(b, bind)){
		col <- rep(col,length.out=length(x))
		if(!add){
			plot(c(x[1],x[1]+b-1)+offset, c(y,y), col=col[1], type='l',...)
		}
		
		for(i in (1+!add):length(x)){
			null<-mapply(function(s,col){ lines(c(s,s+b)+offset,c(ypos[i],ypos[i]),col=col,...)}, x[[i]],col[[i]])
		}
		add <- TRUE
	}
	
	## use lighter colour for overlayed feature
	col <- col2rgb(col)/255
	col <- rgb(sqrt(col[1,]), sqrt(col[2,]*0.5), sqrt(col[3,]))
	
	x <- x.centre - ceiling(bind/2)
	col <- rep(col,length.out=length(x))
	if(!add){
		plot(c(x[1],x[1]+bind-1)+offset, c(y,y), col=col[1], type='l',...)
		if(!missing(extend) && extend > 0){
			lines(c(x-extend, x)+offset, c(y,y), col=col, lend=1)
			lines(c(x + bind + extend - 1, x)+offset, c(y,y), col=col, lend=1)
		} 
	}
	
#	pos <- !add
	for(i in (1+!add):length(x)){
#		if(i > 1 && x[[i]] > x[[i-1]] + bind + ifelse(missing(extend), 0, 2*extend)) pos <- 0
		null<-mapply(function(s,col){ lines(c(s,s+bind)+offset,c(ypos[i],ypos[i]),col=col,...)}, x[[i]],col[[i]])
		if(!missing(extend) && extend > 0){
			null <- mapply(function(x,col) lines(c(x-extend, x)+offset, c(ypos[i],ypos[i]), col=col, lend=1), 
					x[[i]], col[[i]])
			null <- mapply(function(x,col) lines(c(x + bind + extend, x)+offset, c(ypos[i],ypos[i]), col=col, lend=1), 
					x[[i]], col[[i]])
		}
#		pos <- pos + 1
	}
}

.plotReads <- function(x, scale=c("total", "ratio"), log=TRUE, ...){
	stopifnot(is(x, "matrix"), ncol(x) == 2)
	method <- match.arg(scale)
		
	hilbert <- list(HilbertVis::hilbertImage(x[,1]), HilbertVis::hilbertImage(x[,2]))
	
	## process plot parameters
	dots <- list(...)
	if(!is.null(dots$mar)) mar <- dots$mar
	else mar <- c(0,0,4,0)
	if(!is.null(dots$col)) col <- dots$col
	
	oldPar <- par("mar","bg","xpd")
	
	par(mar=mar, bg="gray", xpd=TRUE)
	if(method == "total"){
		data <- hilbert[[1]] + hilbert[[2]]
		if(log) data <- log(data)
		
		if(is.null(dots$col)) col <- fBasics::seqPalette(256,"Blues")
		dataRange <- diff(range(data[is.finite(data)], na.rm=TRUE))
		centre <- as.numeric(!log)
		step <- dataRange/length(col)
		breaks <- c(seq(min(data[is.finite(data)], na.rm=TRUE), centre - step, length.out=length(col)/2), centre, 
				seq(step, max(data[is.finite(data)], na.rm=TRUE), length.out=length(col)/2))
		
		image(data, col=col, breaks=breaks, xaxt="n",yaxt="n")
	}
	else if(method == "ratio"){
		if(log)
			data <- log(hilbert[[1]]) - log(hilbert[[2]])
		else data <- hilbert[[1]]/hilbert[[2]]
		if(is.null(dots$col)) col <- fBasics::divPalette(256,"RdYlGn")
		image(data, col=col,xaxt="n",yaxt="n")		
	}
	## ensure margin background is white
	offset <- 1/(2*(nrow(data)-1)) 
	top <-  grconvertY(grconvertY(1 + offset, "user", "inches") + par("mai")[3], "inches", "user")
	rect(-offset, 1 + offset, 1 + offset, top, col="white", border=NA)
	
	## add title
	if(!is.null(dots$main)) title(dots$main)
	else{
		if(method == "ratio") main <- "Ratio of Read Counts"
		else if(method == "total") main <- "Total Read Counts"
		title(paste(ifelse(log, "Log", ""), main))	
	}
	
	par(oldPar)	
}

####################### conversion #####################################
## convert list of genome coordinates into gff format
## pos: named list with start positions for each chromosome
pos2gff <- function(pos, method, feature, len, strand, score, name){
	total <- sum(S4Vectors::elementNROWS(pos))
	chr <- rep(names(pos), times = S4Vectors::elementNROWS(pos))
	start <- unlist(pos, use.names=FALSE)
		
	method <- rep(method, length.out=total)
	feature <- rep(feature, length.out=total)
	if(missing(strand)) strand <- "."
	strand <- rep(strand, length.out=total)
	if(missing(score)) score <- "."
	score <- rep(score, length.out=total)
	if(missing(name)) name <- paste(feature, 1:total, sep="_")
	name <- paste("name \"", name, "\"", sep='')
	
	data.frame(chromosome=chr, method=method, feature=feature, start=start, 
			end=start+len, score=score, strand=strand, frame=".", name=I(name),
			stringsAsFactors=TRUE)
}


####################### finding binding sites ##########################

## using C code
startScore <- function(data, b, support, background, bgCutoff, supCutoff){
	if(typeof(data) != "integer")
            data <- matrix(as.integer(unlist(data, use.names=FALSE)), ncol = 2)
	score <- .Call(startScore_pois, data, as.integer(b), as.integer(support), as.integer(background), 
			bgCutoff, supCutoff)
	score
}

## given binding site scores (for one chromosome), identify all peaks above given threshold
pickPeak <- function(score, threshold, offset=0, sub=FALSE){
	idx <- which(score > threshold)
	if(length(idx) == 0) return(NULL)
	
	idx.dist <- diff(idx)
	change.at <- which(idx.dist > 1)
	idx.start <- c(1, change.at +1)
	idx.end <- c(change.at, length(idx))
	broadPeak <- IRanges::Views(score, idx[idx.start], idx[idx.end])
	peak <- IRanges::viewWhichMaxs(broadPeak)
	## if the peak is flat we pick the centre
	for(i in 1:length(peak)){
	  runs <- as(broadPeak[[i]][(peak[i] - start(broadPeak)[i] + 1):width(broadPeak)[i]], "Rle")
	  peakWidth <- runLength(runs)[1]
	  if(peakWidth > 1){
	    peak[i] <- peak[i] + floor(peakWidth/2) 
	  }
	}
	if(sub){
		subPeaks <- mapply(function(s,e, x) {
					if(s == e) p <- s + offset
					else if(isTRUE(all.equal(diff(window(x, s, e)), rep(0, e-s)))) 
						p <- s + floor((e - s)/2) + offset
					else if(e-s > 1){
						p <- which(diff(window(x, s, e-1)) >= 0 &  
										diff(window(x, s+1, e)) <= 0) + s + offset
						if(x[s] > x[s + 1]) p <- c(s + offset, p)
						if(x[e] > x[e - 1]) p <- c(p, e + offset)
						drop <- which(diff(p) == 1)
						if(length(drop) > 0) p <- p[-(drop + 1)]
					}
					else p <- which.max(x[s:e]) + s -1 + offset
					p
				},idx[idx.start], idx[idx.end], 
				MoreArgs=list(x=score), SIMPLIFY=FALSE)
		ret <- list(peaks=peak+offset, subPeaks=subPeaks)
	}
	else ret <- peak + offset
	
	return(ret)
}

## determine significance threshold for binding site scores
## alpha is the target level of the FDR (which will be adapted to the data)
getCutoff <- function(score, alpha = 0.05, tailCut=0.95, adapt=FALSE, lambda, plot = TRUE, returnPval = TRUE){
	nllk <- function(sd, x, cutoff){
		dnom <- log(pnorm(cutoff, sd=sd, log.p=FALSE) - pnorm(0, sd=sd, log.p=FALSE))
		-(sum(dnorm(x[x < cutoff], sd=sd, log=TRUE) - dnom))
	}
	
	score <- score[!is.na(score)]
	score2 <- -score[score <= median(score)]
	score2 <- score2 - min(score2)
	
	fit <- optimize(nllk, c(.Machine$double.eps, .Machine$double.max), x=score2, cutoff=quantile(score2, tailCut))
	sigma <- fit$minimum
	pval <- pnorm(score, mean=median(score), sd=sigma, lower.tail=FALSE)
	fdr <- p.adjust(pval, "BH")
	
	pi0 <- NA
	if(adapt){
		F_hat <- sum(pval <= lambda)/length(pval)
		pi0 <- min(1, (1 - F_hat)/(1 - lambda))
		alpha <- alpha/pi0
	}
	
	cutoff <- ifelse(min(fdr) > alpha, Inf, min(score[fdr <= alpha])) 
	
#	if(plot){
#		range <- max(score) - min(score)
#		breaks <- seq(min(score), max(score), length.out=max(range, 100))
#		hist(score, breaks=breaks, freq=FALSE, main="Empirical and fitted null distribution", xlab="Score")
#		lines(seq(min(score), max(score), by=0.1), dnorm(seq(min(score), max(score), by=0.1),
#						mean=median(score), sd=sigma), col=2)
#		if(is.finite(cutoff)) abline(v=cutoff, col=4, lty=2)
#	}
	
	## assemble result
	result <- list(cutoff=c(cutoff, alpha), h0=c(median(score), sigma))
	names(result$cutoff) <- c("cutoff", "alpha")
	names(result$h0) <- c("mean", "sd")
	
	if(returnPval) result[["pvalue"]] <- fdr
	if(adapt) result[["pi0"]] <- pi0
	
	return(result)
}

## calculate cross-correlation between strands
getBindCor <- function(data, max.lag, summary, plot=TRUE, ...){
	result <- sapply(lapply(decompress(data), timsac::fftcor, lag=max.lag, plot=FALSE), function(x) x$ccor21)
	
	if(plot){
		matplot(0:max.lag,result, type='l', xlab="Lag", ylab="Cross-correlation", 
				main="Correlation between forward and reverse strand", lty=1:5, col=1:6)
		if(is.null(names(data))) names <- 1:length(data)
		else names <- names(data)
		if(length(names) > 1 )legend("topright", legend=names, col=1:6, lty=1:5)
	}
	
	if(!missing(summary)) result <- apply(result, 1, summary)
	
	result
}

## identify peaks in cross-correlation between strands to determine binding site length (and optionally support region length)
## bind and support give the maximum (and optionally minimum) length for binding site and support region
##
## Note that the assumption that the first peak in the cross-correlation indicates the length of the binding site 
## is not accurate. The peak is closer to bind + 2*m where m is the median of the read distribution in the support region.
## ('read distribution in the support region' means the read density as a function of distance to binding site start/end)
## Consequently this method will overestimate the length of the binding site.
## If either bind or support are of length 1 this is assumed to be the known value and a more accurate estimate for the
## remaining parameter is used.
getBindLen <- function(data, bind, support, summary=median, verbose=FALSE, plot=TRUE, ...){
	max.lag <- ifelse(missing(support), ceiling(max(bind)*1.5), 2*max(bind)+ceiling(max(support)*1.5))
	bindCor <- getBindCor(data, max.lag, summary, plot=FALSE, ...)
	
	## fit smoothing spline 
	bindSpline <- smooth.spline(0:(length(bindCor)-1), bindCor)
	
	#determine lag that maximises correlation, this should be close to length of binding site
	if(length(bind) == 1){
		bindLen <- bind
		#supLen <- which.max(bindSpline$y[(bind + min(support)):(bind + max(support)) + 1]) + min(support) - 1
		supPeak <- which.max(window(bindSpline$y, bindLen + 2*min(support),
						bindLen + 2*max(support) + 1)) + bindLen + 2*min(support) - 1
		supLen <- round((supPeak - bindLen) * 0.5)
		bindPeak <- supPeak   ## need only location of first peak 
		if(verbose) message("Estimated length of support region: ", supLen)
	}
	else{
		if(length(support) == 1){
			supLen <- support
			bindPeak <- which.max(window(bindSpline$y, supLen + min(bind), 
									supLen + max(bind) + 1)) +	min(bind) + supLen -1 
			bindLen <- bindPeak - 2*supLen
			supPeak <- bindPeak   ## need only location of first peak
			if(verbose) message("Estimated length of binding site: ", bindLen)
		}
		else{
			bindPeak <- which.max(window(bindSpline$y, support[1] + bind[1],
							support[2] + bind[2]+1)) + bind[1] + support[1] - 1
			if(!missing(support) && length(support) > 1){
				supLen <- which.max(window(bindSpline$y, 2*bindPeak+support[1],
								2*bindPeak+support[2]+1)) +	support[1] - 1 
				bindLen <- bindPeak - 2*supLen
				supPeak <- 2*bindPeak + supLen
				if(verbose) message("Estimated length of support region: ", supLen)
			}
			
			if(verbose) message("Estimated length of binding site: ", bindLen)
		}
	} 
		
	result <- c(bind=bindLen, support=supLen)
		
	if(plot){
		plot(0:max.lag, bindCor, xlab="Lag", ylab="Cross-correlation")
		lines(bindSpline, col=2)
		if(length(bind) > 1) abline(v=bind + support, lty=2)
		if(!missing(support) && length(support) > 1) 
			abline(v=if(length(bind)>1) 2*bindPeak+support else bindLen+2*support, lty=2)
		if(length(bind) > 1) abline(v=bindPeak, lty=3, col=2)
		if(!missing(support) && length(support) > 1) abline(v=supPeak, lty=3, col=3)
	}
	
	result
}


## call nucleosomes. This is just for convenience  
simpleNucCall <- function(data, bind=128, support=17, background=2000, chrLen, ...){
	if(!missing(chrLen))
		callBindingSites(data, bind=bind, support=support, background=background, chrLen=chrLen, ...)
	else
		callBindingSites(data, bind=bind, support=support, background=background, ...)
}

## x is position, y is score. The higher scoring of two overlapping entries is retained
## if y is missing the first entry is chosen
.noOverlap <- function(x, y, minDist){
	result <- numeric(length(x))
	result[1] <- x[1]
	count <- 1
	idx <- 1
	if(length(x) > 1) 
		for(i in 2:length(x)){
			if(x[i] >= result[count] + minDist){
				result[count+1] <- x[i]
				count <- count + 1
				idx <- i
			}
			else if(!missing(y)){
				if(y[i] > y[idx]) result[count] <- x[i]
			}
		}
	length(result) <- count
	result
}

## get sequences for predicted binding sites, removing overlaps by default
exportBindSequence <- function(prediction, reference, bind, overlap=FALSE, file=""){
	## check arguments
	stopifnot(is(prediction, "BindScore"))
	stopifnot(is(reference, "XStringSet"))
	if(missing(bind)) bind <- prediction@functionCall$bind
	
	## predicted binding sites
	peaks <- as.data.frame(prediction)
	peaks <- lapply(levels(peaks$chromosome), function(chr) subset(peaks, chromosome==chr)[,2:3])
	## remove overlap
	if(!overlap)
		peaks <- lapply(peaks, function(x) .noOverlap(x[,1], x[, 2], minDist=bind))
	else peaks <- lapply(peaks, "[[", 1)
	
	start <- lapply(peaks, "-", floor(bind/2))
	end <- lapply(peaks, "+", floor(bind/2))
	
	seqs <- mapply(function(chr, s, e) Views(reference[[chr]], start=s, end=e, 
						names=paste("site", chr, 1:length(s), sep="_")), 1:length(names(prediction)), start, end)	
	
	if(file=="") return(seqs)
	
	files <- sapply(names(prediction), function(chr) paste(file, "_", chr, ".fasta", sep=""))
	mapply(function(x, file, format) writeXStringSet(as(x, "XStringSet"), file), seqs, files)
	
	invisible(seqs)
}

allWords <- function(alphabet, n){
	x <- vector(n, mode="list")
	for(i in 1:n) x[[i]] <- alphabet
	df <- expand.grid(x)
	result <- character(nrow(df))
	for(i in 1:n) result <- paste(result, df[[i]], sep="")
	result
}

allGroups <- function(alphabet, n){
	words <- allWords(alphabet, n)
	groups <- lapply(words, I)
	names(groups) <- words
	
	groups
}


.nucFreq <- function(seq, classes=list(AT=c("AA","AT", "TA", "TT"), GC=c("CC", "CG", "GC", "GG"))){
	patternLen <- nchar(classes[[1]][1])
	counts <- matrix(0, nrow=nchar(seq) - patternLen + 1, ncol=length(classes))
	colnames(counts) <- names(classes)
	for(i in 1:(nchar(seq) - patternLen + 1)){
		counts[i,] <- counts[i,] + sapply(classes, function(x) substr(seq, i, i + patternLen - 1) %in% x)
	}
	counts
}

views2nucFreq <- function(x, classes=list(AT=c("AA","AT", "TA", "TT"), GC=c("CC", "CG", "GC", "GG"))){
	stopifnot(is(x, "XStringViews"))
	patternLen <- nchar(classes[[1]][1])
	## TODO: check pattern length
	
	counts <- matrix(0, nrow=max(width(x)) - patternLen + 1, ncol=length(classes))
	colnames(counts) <- names(classes)
	
	for(i in 1:length(x)){
		f <- .nucFreq(toString(x[i]), classes)
		if(nrow(f) == nrow(counts))	counts <- counts + f
		## TODO: not sure how to best handle this. Only use for uniform windows!
	}
	
	counts
}

.twoWayTest <- function(x, classes=c("A", "C", "G", "T"), df, blocked=FALSE){
	if(is.list(classes)){
		classes1 <- classes[[1]]
		classes2 <- classes[[2]]
	}
	else{
		classes1 <- classes2 <- classes
	}
	dfOffset <- 0
	
	x <- matrix(x, nrow=length(classes1))
	rownames(x) <- classes1
	colnames(x) <- classes2
	
	if(blocked > 0){
		nblock <- nrow(x)/4
		#overlap <- 2*nchar(classes1[1]) - nchar(colnames(x)[1])
		
		blockIdx <- numeric(nblock)
		block <- 1
		for(i in seq(1,length(classes1), by=4)){
			pattern <- substr(classes1[i], nchar(classes1[i]) - blocked + 1, nchar(classes1[i]))
			for(j in 1:length(classes2))
				if(substr(classes2[j], 1, blocked) == pattern){
					blockIdx[block] <- j
					break
				}
			block <- block + 1
		}
		
		result <- vector(nblock, mode="list")
		for(i in 1:nblock){
			result[[i]] <- Recall(x[((i-1)*4+1):(i*4), (blockIdx[i]):(blockIdx[i]+3)])
		}
		
		stat <- sum(sapply(result, "[[", "statistic"))
		df <- sum(sapply(result, "[[", "df"))
		comp <- matrix(0, nrow=nrow(x), ncol=ncol(x))
		for(i in 1:nblock)
			comp[((i-1)*4+1):(i*4), (blockIdx[i]):(blockIdx[i]+3)] <- result[[i]]$components
	}
	else{
		relFreq <- x/sum(x)
		
		m <- list()
		m[[1]] <- rowSums(relFreq)
		m[[2]] <- colSums(relFreq)
		expected <- matrix(apply(expand.grid(m),1,prod)*sum(x),nrow=nrow(x))
		isNull <- sapply(expected, function(x) isTRUE(all.equal(x,0)))
		
		comp <- ifelse(isNull, 0, sign(x - expected) * sqrt((x - expected)^2/expected))
		stat <- sum(comp^2)
		dfOffset <- sum(isNull)
		if(dfOffset) warning("Table contains zero counts. Result may be unreliable.")
	}
	if(missing(df) && blocked) df <- 9 * nblock -dfOffset
	if(missing(df)) df <- (nrow(x)-1)*(ncol(x)-1) - dfOffset
	
	pvalue <- pchisq(stat, df, lower.tail=FALSE)
	
	list(statistic=stat, pvalue=pvalue, components=comp, df=df)
}


.oneWayTest <- function(freq, ref){
	if(any(ref > 1)) ref <- ref/sum(ref)
	expected <- ref * sum(freq[1,])
	comp <- t(apply(freq, 1, function(x) sign(x - expected) * sqrt((x - expected)^2/expected)))
	stat <- rowSums(comp^2)
	pvalue <- pchisq(stat, ncol(freq) -1, lower.tail=FALSE )
	
	list(statistic=stat, pvalue=pvalue, components=comp)
}

diNucTest <- function(dinucFreq, reference){
	order <- c("AA","CA","GA", "TA","AC","CC","GC","TC","AG","CG","GG","TG", "AT","CT","GT","TT")
	dinucFreq <- dinucFreq[, order]
	
	if(missing(reference)){
		## two-way test
		#test <- apply(dinucFreq, 1, .diNucChisqTest2)
		test <- apply(dinucFreq, 1, .twoWayTest)
		stat <- sapply(test, "[[", "statistic")
		pvalue <- sapply(test, "[[", "pvalue")
		comp <- t(sapply(test, function(x) c(x[["components"]])))
		colnames(comp) <- order
	}
	else{
		## one-way test
		reference <- reference[order]
		test <- .oneWayTest(dinucFreq, reference)
		comp <- test$components
		stat <- test$statistic
		pvalue <- test$pvalue
		colnames(comp) <- order
	}
	
	list(statistic=stat, pvalue=pvalue, components=comp)
}

.triNucStat <- function(nuc, mononucFreq, dinucFreq, trinucFreq, n){
	expected <- dinucFreq[-1, substr(nuc,2,3)]/mononucFreq[-c(1,nrow(mononucFreq)), substr(nuc,2,2)]
	observed <- trinucFreq[ , nuc]/n
	
	(observed - expected)^2/expected
}
triNucTest2 <- function(trinucFreq){
	order <- mkAllStrings(c("A", "C", "G", "T"), 3)
	trinucFreq <- trinucFreq[, order]
	subStr1 <- mkAllStrings(c("A", "C", "G", "T"), 2, "left")
	subStr2 <- mkAllStrings(c("A", "C", "G", "T"), 2, "right")
	classes <- expand.grid(subStr1, subStr2)
	
	table <- matrix(0, ncol=nrow(classes), nrow=nrow(trinucFreq))
	idx <- numeric(ncol(trinucFreq))
	names(idx) <- order
	for(nuc in order){
		idx[nuc] <- which(classes[,1] == substr(nuc, 1, 2) & classes[,2] == substr(nuc, 2, 3))
		table[,idx[nuc]] <- trinucFreq[, nuc]
	}
	## df = 36 = 4*9 (9 df from each of the 4 blocks)
	test <- apply(table, 1, .twoWayTest, classes=list(subStr1,subStr2), df=36, blocked=TRUE) 
	
	## restructure result
	stat <- sapply(test, "[[", "statistic")
	pval <- sapply(test, "[[", "pvalue")
	comp <- t(sapply(test, function(x) x$components[idx]))
	colnames(comp) <- order
	
	list(statistic=stat, pvalue=pval, components=comp)
}

triNucTest1 <- function(trinucFreq, reference){
	## one-way test
	reference <- reference[colnames(trinucFreq)]
	.oneWayTest(trinucFreq, reference)
}

## two way test for arbitrarily long nucleotides
oligoNucTest <- function(oligoFreq, alphabet=c("A", "C", "G", "T"), subLen){
	if(missing(subLen)) subLen <- nchar(colnames(oligoFreq)[1]) - 1
	oligo <- nchar(colnames(oligoFreq)[1])
	
	## row and column classes
	subStr1 <- mkAllStrings(alphabet, subLen, "left")
	subStr2 <- mkAllStrings(alphabet, subLen, "right")
	classes <- expand.grid(subStr1, subStr2)
	
	## expand table, each row contains all entries of table for one position
	table <- matrix(0, ncol=nrow(classes), nrow=nrow(oligoFreq))
	idx <- numeric(ncol(oligoFreq))
	names(idx) <- colnames(oligoFreq)
	for(nuc in colnames(oligoFreq)){
		idx[nuc] <- which(classes[,1] == substr(nuc, 1, subLen) & classes[,2] == substr(nuc, oligo-subLen+1, oligo))
		table[,idx[nuc]] <- oligoFreq[, nuc]
	}
	
	## position specific two-way chi^2 test
	test <- apply(table, 1, .twoWayTest, classes=list(subStr1,subStr2), blocked=2*subLen - oligo)

	## restructure result
	stat <- sapply(test, "[[", "statistic")
	pval <- sapply(test, "[[", "pvalue")
	comp <- t(sapply(test, function(x) x$components[idx]))
	colnames(comp) <- colnames(oligoFreq)
	df <- sapply(test, "[[", "df")
	
	list(statistic=stat, pvalue=pval, components=comp, df=df)
}

plotFreq <- function(data, nameLen=1, alphabet=c("A", "C", "G", "T"), 
		xlim=c(-200, 200), bind=c(-73, 73), support=10, range=c(-500,499)){
	par.old <- par(no.readonly=TRUE)
	layout.mat <- matrix(1:16,ncol=4)
	par(mar=rep(0, 4))
	par(oma=rep(4.1, 4))
	layout(layout.mat)
	
	rowNames <- mkAllStrings(alphabet, nameLen, "left")
	colNames <- mkAllStrings(alphabet, nameLen, "right")
	
#	rowNames <- unique(sapply(colnames(data), function(x) substr(x, 1, nameLen)))
#	colNames <- unique(sapply(colnames(data), function(x) substr(x, nchar(x) - nameLen + 1, nchar(x))))

	bindLen <- bind[2]-bind[1]
	ticks <- c(seq(sign(bind[1])*ceiling(bindLen/5)*5, xlim[1], by=-ceiling(bindLen/5)*5), 
			bind[1], (bindLen)/2 + bind[1], bind[2], 
			seq(sign(bind[2])*ceiling(bindLen/5)*5, xlim[2], by=ceiling(bindLen/5)*5))
	
	## determine row and column indices for plotting of 4x4 blocks
	row <- numeric()
	for(i in seq(4, length(rowNames), by=4)) row <- c(row, rep((i-3):i, times=4))
	row <- rep(row, times=ceiling(length(colNames)/4))
	
	col <- numeric()
	for(i in seq(4, length(colNames), by=4)) col <- c(col, rep(rep((i-3):i, each=4), 
						times=ceiling(length(colNames)/4)))
	
	## if plotting a blocked design, i.e. row and column names overlap, remove all
	## non matching combinations (structural 0s)
	overlap <- 2*nameLen - nchar(colnames(data)[1])
	if(overlap){
		match <- mapply(function(r, c) 
					substr(rowNames[r], nameLen-overlap +1, nameLen) == substr(colNames[c], 1, overlap), 
				row, col)
		row <- row[match]
		col <- col[match]
	}
	
	idx <- 1:length(row)
	for(i in idx){
		nuc <- paste(rowNames[row[i]], substr(colNames[col[i]], overlap + 1, nameLen), sep="")
		
		plot(range[1]:range[2], data[,nuc], ylim=range(data),xlim=xlim,xaxt="n", yaxt="n", xlab="", ylab="")
		lines(bind, c(0,0), col=rgb(0,1,0, 0.75), lwd=3, lend=1)
		lines(bind + c(-support, support), c(0,0), col=rgb(0,1,0, 0.75), lwd=1, lend=1)
		sp <- smooth.spline(range[1]:range[2], data[,nuc], nknots=200)
		lines(sp, col=2)
		
		if(col[i]%%4 == 1){
#			if(length(rowNames)*length(colNames) == ncol(data))
			mtext(rowNames[row[i]], 2, 2)
#			else ## blocked layout
#				mtext(rowNames[floor(i/16)*4 + ((i-1)%%16)+1], 2, 2)
		}
		if(col[i] %% 4 == 0){
			axis(4)
		}
		if(row[i] %% 4 == 1){
#				if(length(rowNames)*length(colNames) == ncol(data))
			mtext(colNames[col[i]], 3, 2)
#				mtext(colNames[floor(i/16) * 4 + (((((i - 1)%%16) + 1)/4) + 1)], 3, 2)
		}
		if(row[i] %% 4 == 0){
			axis(1, at=ticks)
		}
		if(row[i]*col[i] %% 16 == 0){
			mtext("Distance from nucleosome centre", 1, 3, outer=TRUE)
			mtext("Score", 4, 3, outer=TRUE)
		}
	}
	
#	for(i in 1:ncol(data)){
#		plot(range[1]:range[2], data[,i], ylim=range(data),xlim=xlim,xaxt="n", yaxt="n", xlab="", ylab="")
#		lines(bind, c(0,0), col=rgb(0,1,0, 0.75), lwd=3, lend=1)
#		lines(bind + c(-support, support), c(0,0), col=rgb(0,1,0, 0.75), lwd=1, lend=1)
#		sp <- smooth.spline(range[1]:range[2], data[,i], nknots=200)
#		lines(sp, col=2)
#		row <- (i-1)%%length(rowNames) + 1
#		col <- ceiling(i/length(rowNames))
#		if(col%%4 == 1){
##			if(length(rowNames)*length(colNames) == ncol(data))
#				mtext(rowNames[row], 2, 2)
##			else ## blocked layout
##				mtext(rowNames[floor(i/16)*4 + ((i-1)%%16)+1], 2, 2)
#		}
#		if((((i-1)%%16)+1) %in% 13:16){
#			axis(4)
#		}
#		if((((i-1)%%16)+1) %in% c(1,5,9,13)){
#			if(length(rowNames)*length(colNames) == ncol(data))
#				mtext(colNames[floor(i/16)+1], 3, 2)
#			mtext(colNames[floor(i/16) * 4 + (((((i - 1)%%16) + 1)/4) + 1)], 3, 2)
#		}
#		if((((i-1)%%16)+1) %in% c(4,8,12,16)){
#			axis(1, at=ticks)
#		}
#		if(i %% 16 == 0){
#			mtext("Distance from nucleosome centre", 1, 3, outer=TRUE)
#			mtext("Score", 4, 3, outer=TRUE)
#		}
#	}
	
	par(par.old)
}

.oligonucSim <- function(freq1, freq2, oligo=3, iter=3000){
	freq1 <- freq1[mkAllStrings(c("A", "C", "G", "T"), oligo-1, "left")]
	freq2 <- freq2[mkAllStrings(c("A", "C", "G", "T"), oligo-1, "right")]
	
	## calculate oligonucleotide frequencies
	oligonuc <- mkAllStrings(c("A", "C", "G", "T"), oligo)
	oligonucFreq <- numeric(length(oligonuc))
	names(oligonucFreq) <- oligonuc
	for(nuc in oligonuc){
		oligonucFreq[nuc] <- freq1[substr(nuc, 1, oligo-1)] * freq2[substr(nuc, 2, oligo)]
	}
	
	## generate oligonucleotide counts
	oligonucSample <- sample(oligonuc, iter, prob=oligonucFreq, replace=TRUE)
	oligonucSample <- table(oligonucSample)
	
	## arrange oligonucleotides into blocks
	classes <- expand.grid(names(freq1), names(freq2))
	table <- numeric(nrow(classes))
	idx <- numeric(length(oligonuc))
	names(idx) <- oligonuc
	for(nuc in oligonuc){
		idx[nuc] <- which(classes[,1] == substr(nuc, 1, oligo-1) & classes[,2] == substr(nuc, 2, oligo))
		table[idx[nuc]] <- ifelse(is.na(oligonucSample[nuc]), 0, oligonucSample[nuc])
	}
		
	test <- .twoWayTest(table, classes=list(names(freq1), names(freq2)), blocked=oligo-2)
	test$statistic
}

## print head and tail of a vector
.headTail <- function(x, n = 6L){
	start <- paste(head(x, n), collapse = ", ")
	middle <- if(length(x) == 2*n + 1) {
		paste(", ", x[n+1], ", ", sep="") 
	}else if(length(x) > 2*n + 1) ", ..., " else if(length(x) < 2*n + 1 && length(x) > n) ", "
	end <- if(length(x) > n) paste(tail(x, min(n, length(x) - n)), collapse = ", ")
	paste(start, middle, end, sep = "")
} 

## helper function to print common information about objects of classes defined in this package
.showHeader <- function(object){
	cat("Class:", class(object),"\n")
	if("functionCall" %in% slotNames(object)){
		cat("Generated by: ")
		show(object@functionCall)
	}
	cat("Chromosomes: ", length(chrLength(object)), " (", .headTail(names(object), 2) ,")\n", sep="")
	cat("Genome length:", sum(chrLength(object)), "\n")
}

## calculate p-values
.score2pval <- function(score, null){
	
	scores <- c(lapply(score, function(y) 
						as.numeric(y[!is.na(y)])), recursive=TRUE)
	pval <- pnorm(scores, mean=null["mean"], sd=null["sd"], lower.tail=FALSE)
	pval <- p.adjust(pval, "BH")
	## split back into chromosomes
	len <- sapply(score, function(y) sum(!is.na(y)))
	end <- cumsum(len)
	start <- c(1, end[-length(end)]+1)
	
	result <- vector(mode="list", length(score))
	for(i in 1:length(result)){
		result[[i]][!is.na(score[[i]])] <- pval[start[i]:end[i]]
	}
	result
}

## append trailing zeros to get full chromosome length
## returns RleList with read counts for both strands
.fixCounts <- function(counts, totalLen){
	countLen <- sapply(counts, length)
	if(countLen[1] < totalLen){
		counts[[1]]@lengths <- c(runLength(counts[[1]]), as.integer(totalLen) - countLen[1])
		counts[[1]]@values <- c(runValue(counts[[1]]), 0L)
	}
	if(countLen[2] < totalLen){
		counts[[2]]@lengths <- c(runLength(counts[[2]]), as.integer(totalLen) - countLen[2])
		counts[[2]]@values <- c(runValue(counts[[2]]), 0L)
	}
	
	RleList(counts[[1]], counts[[2]])
}

# New generic functions
# 
# Author: Peter Humburg
###############################################################################

## create strand specific read counts
setGeneric("strandPileup", def=function(aligned, chrLen, ...) standardGeneric("strandPileup"))

## call binding sites
## Convenience function for one step analysis
## This function combines the different steps required to identify nucleosomes into a single function.
## 'data' is either an object with mapped reads or a list with read counts (as returned by strandPileup).
## Defaults provided for the various parameters should be reasonable for nucleosome data.
## An attempt is made to determine the length of binding and support regions from the data if more than one value
## is provided, see getBindLen for details.
## Returns a list with components 
##    binding: a data.frame with predicted binding site centres and associated scores and p-values
##    score: a list with all calculated scores (one numeric vector per chromosome)
##    pval: a list with all calculated p-values (one numeric vector per chromosome)
setGeneric("callBindingSites", def=function(data, ...) standardGeneric("callBindingSites"))


## accessors for slots of BindScore
setGeneric("pvalue", def=function(x, ...) standardGeneric("pvalue"), useAsDefault=function(x, ...) x@pvalue)
#setGeneric("score", def=function(x, ...) standardGeneric("score"), useAsDefault=function(x, ...) x@score)
setGeneric("peaks", def=function(x, ...) standardGeneric("peaks"), useAsDefault=function(x, ...) x@peaks)
setGeneric("binding", def=function(x, ...) standardGeneric("binding"), useAsDefault=function(x, ...) x@binding)
setGeneric("support", def=function(x, ...) standardGeneric("support"), useAsDefault=function(x, ...) x@support)
setGeneric("cutoff", def=function(x, ...) standardGeneric("cutoff"), useAsDefault=function(x, ...) x@cutoff)
setGeneric("cutoff<-", def=function(x, ..., value) standardGeneric("cutoff<-"), 
		useAsDefault=function(x, ...,  value) x@cutoff <- value)
setGeneric("nullDist", def=function(x, ...) standardGeneric("nullDist"), useAsDefault=function(x, ...) x@nullDist)
setGeneric("nullDist<-", def=function(x, ..., value) standardGeneric("nullDist<-"), 
		useAsDefault=function(x, ..., value) x@nullDist <- value)

## explicit conversion between compressed and expanded representations
setGeneric("compress", def=function(x, ...) standardGeneric("compress"))
setGeneric("decompress", def=function(x, ...) standardGeneric("decompress"), useAsDefault=function(x, ...) x)

## create S4 generics for some existing (S3) methods
setGeneric("lapply")
setGeneric("sapply")
setGeneric("as.data.frame")
setGeneric("head", useAsDefault=utils::head)
setGeneric("tail", useAsDefault=utils::tail)
setGeneric("plot", useAsDefault=graphics::plot)

## summary functions
##    number of reads in sample
setGeneric("nreads", def=function(x, ...) standardGeneric("nreads"))
##    length of chromosomes
setGeneric("chrLength", def=function(x, ...) standardGeneric("chrLength"))

# constructors for S4 classes defined in classes.R
# 
# Author: Peter Humburg
###############################################################################

setMethod("initialize", c("ReadCounts"),
		function(.Object, counts=list(), names=NULL, ...){
			stopifnot(is.list(counts))
			
			.Object <- callNextMethod(.Object, ...)
			
			## ensure we have chromosome names
			if(!is.null(names)) names(counts) <- names
			if(is.null(names(counts))) 
				stop("Chromosome names are missing.")
			
			## ensure that counts is integer matrix
			if(!all(sapply(counts, is.matrix))){
				counts <- lapply(counts, 
						function(x){
							if(is.matrix(x)) return(x)
							else{
								warning("Converting entry to two column matrix.")
								return(matrix(x, ncol=2))
							} 
						})
			}
			if(!all(sapply(counts, is.integer))){
				counts <- lapply(counts, function(x) matrix(as.integer(x), ncol=2))
			}
			
			## set column names to indicate strand
			counts <- lapply(counts, "colnames<-", c("+", "-"))
	
			.Object@counts <- counts
			
			.Object
		}
)

setMethod("initialize", c("RLEReadCounts"), 
		function(.Object, counts=list(), names=NULL, ...){
			stopifnot(is.list(counts))
			## ensure we have chromosome names
			if(!is.null(names)) names(counts) <- names
			if(is.null(names(counts))) 
				stop("Chromosome names are missing.")
			
			## ensure that counts is integer matrix
			idx <- !(sapply(counts, is.matrix) | sapply(counts, is, "RleList"))
			if(any(idx)){
				counts[idx] <- lapply(counts[idx], 
						function(x){
							warning("Converting entry to two column matrix.")
							return(matrix(x, ncol=2)) 
						})
			}
			idx <- !(sapply(counts, is.integer) | sapply(counts, is, "RleList"))
			if(any(idx))
				counts[idx] <- lapply(counts[idx], function(x) matrix(as.integer(x), ncol=2))
			
			## compress read counts
			idx <- !sapply(counts, is, "RleList")
			counts[idx] <- lapply(counts[idx], function(x) IRanges::RleList(IRanges::Rle(x[, 1]), IRanges::Rle(x[, 2])))
			counts[idx] <- lapply(counts[idx], "names<-", c("+", "-"))
			
			.Object@counts <- counts
			
			.Object
		}
)

## assumes that the function that was called to compute these results had arguments
## 'bind' and 'support' referring to the length of binding and support regions
setMethod("initialize", "BindScore",
		function(.Object, functionCall, score=list(), pvalue=list(), peaks=list(), cutoff=c(-Inf, 1), 
				nullDist=c(0, 1), names=NULL, start=1L, digits=16, ...){
			.Object <- callNextMethod(.Object, ...)
			
			## ensure we have chromosome names
			if(any(sapply(list(names(score), names(pvalue), names(peaks)), is.null)) ||
					!(all.equal(names(score), names(pvalue)) && all.equal(names(score), names(peaks)))){
				## ensure all names match given chromosome names
				names(score) <- names
				names(pvalue) <- names
				names(peaks) <- names
			}
			if(is.null(names(score))) 
				stop("Chromosome names are missing.")
			
			if(length(cutoff) < 2) stop("Argument 'cutoff' has to be of length 2.")
			if(length(cutoff) > 2){
				warning("'cutoff' has length ", length(cutoff), ". Truncating to length 2.")
				length(cutoff) <- 2
			}
			names(cutoff) <- c("score", "pvalue")
			
			if(length(nullDist) < 2) stop("Argument 'nullDist' has to be of length 2.")
			if(length(nullDist) > 2){
				warning("'nullDist' has length ", length(nullDist), ". Truncating to length 2.")
				length(nullDist) <- 2
			}
			names(nullDist) <- c("mean", "sd")
			
			.Object@functionCall <- functionCall
			.Object@score <- score
			.Object@pvalue <- pvalue
			.Object@peaks <- peaks
			.Object@cutoff <- cutoff
			.Object@nullDist <- nullDist
			.Object@start <- as.integer(start)
			
			.Object
		}
)

setMethod("initialize", "RLEBindScore",
		function(.Object, functionCall, score=list(), pvalue=list(), peaks=list(), cutoff=c(-Inf, 1), 
				nullDist=c(0, 1), names=NULL, start=1L, digits=16, ...){
			
			## ensure we have chromosome names
			if(any(sapply(list(names(score), names(pvalue), names(peaks)), is.null)) ||
					!(all.equal(names(score), names(pvalue)) && all.equal(names(score), names(peaks)))){
				## ensure all names match given chromosome names
				names(score) <- names
				names(pvalue) <- names
				names(peaks) <- names
			}
			if(is.null(names(score))) 
				stop("Chromosome names are missing.")
			
			if(length(cutoff) < 2) stop("Argument 'cutoff' has to be of length 2.")
			if(length(cutoff) > 2){
				warning("'cutoff' has length ", length(cutoff), ". Truncating to length 2.")
				length(cutoff) <- 2
			}
			names(cutoff) <- c("score", "pvalue")
			
			if(length(nullDist) < 2) stop("Argument 'nullDist' has to be of length 2.")
			if(length(nullDist) > 2){
				warning("'nullDist' has length ", length(nullDist), ". Truncating to length 2.")
				length(nullDist) <- 2
			}
			names(nullDist) <- c("mean", "sd")
			
			.Object@functionCall <- functionCall
			
			## compress scores and p-values
			idx <- !sapply(score, is, "Rle")
			score[idx] <- lapply(score[idx], function(x){ 
						x[is.na(x)] <- -Inf 
						x <- Rle(round(x, digits=digits))
						runValue(x)[is.infinite(runValue(x))] <- NA
						x
					}
			) 
			.Object@score <- score
			
			idx <- !sapply(pvalue, is, "Rle")
			pvalue[idx] <- lapply(pvalue[idx], function(x){ 
						x[is.na(x)] <- Inf 
						x <- Rle(round(x, digits=16))
						runValue(x)[is.infinite(runValue(x))] <- NA
						x
					}
			)
			.Object@pvalue <- pvalue  
						
			.Object@peaks <- peaks
			.Object@cutoff <- cutoff
			.Object@nullDist <- nullDist
			.Object@start <- as.integer(start)
			
			.Object
		}
)


## constructors that allow to choose between compressed and non-compressed versions
## These could also contain some logic to determine whether compression is likely to be beneficial
ReadCounts <- function(counts=list(), names=NULL, compress=TRUE){
	if(compress) new("RLEReadCounts", counts=counts, names=names)
	else new("ReadCounts", counts=counts, names=names)
}

BindScore <- function(call, score=list(), pvalue=list(), peaks=list(), cutoff=c(-Inf, 1), 
		nullDist=c(0, 1), names=NULL, start=1L, compress=TRUE, digits=16){
	if(compress) new("RLEBindScore", functionCall=call, score=score, pvalue=pvalue, peaks=peaks, cutoff=cutoff,
				nullDist=nullDist, names=names, start=start, digits=digits)
	else new("BindScore", functionCall=call, score=score, pvalue=pvalue, peaks=peaks, cutoff=cutoff,
				nullDist=nullDist, start=start, names=names)
}

# S4 class definitions
# 
# Author: Peter Humburg
###############################################################################


## Class representing strand specific read counts
setClass("ReadCounts", representation=representation(counts="list"), prototype=prototype(counts=list()))

## Class representing scored binding sites
## contains all computed scores and associated p-values as well as the location of predicted binding sites
setClass("BindScore", 
		representation=representation(functionCall="call", score="list", 
				pvalue="list", peaks="list", cutoff="numeric", nullDist="numeric", start="integer"),
		prototype=prototype(score=list(), pvalue=list(), peaks=list(), cutoff=numeric(), 
				nullDist=numeric(), start=0L))

## variants of the above using run-length encoding to reduce memory requirements
setClass("RLEReadCounts", contains="ReadCounts")
setClass("RLEBindScore", contains="BindScore")

% \VignetteIndexEntry{Introduction to ChIPseqR}
\documentclass[a4paper]{article}
\usepackage[OT1]{fontenc}
\usepackage{Sweave}
\usepackage{url}
\usepackage{hyperref}
\usepackage{fullpage}

\begin{document}

\title{Introduction to ChIPseqR}
\author{Peter Humburg}

\maketitle

\section{Introduction}
The \texttt{ChIPseqR} package was developed for the analysis of nucleosome ChIP-seq data.
It is suitable for the high resolution analysis of end-sequenced nucleosomes after MNase digest 
and can be used for the analysis of nucleosome positioning as well as histone modification experiments.
The parameters of the model used by \texttt{ChIPseqR} provide some flexibility and choosing 
them appropriately should allow for the analysis of other types of experiments although this 
has not been tested extensively. In the following sections we will discuss the application 
of \texttt{ChIPseqR} to simulated nucleosome sequencing data to demonstrate its basic
functionality. This is followed by some details on the underlying method and 
a discussion of how this method may be adapted to other types of experiments. 
   
\section{Simulating data}
We start by simulating a small dataset representing reads from a nucleosome positioning experiment.
The information in this section details the data used for the following examples. To quickly 
see an application of \texttt{ChIPseqR} just skip ahead to the next section.

For the purpose of this example we will restrict ourselves to a very small genome and 
relatively few reads. This keeps time and memory requirements low but may affect 
\texttt{ChIPseqR}'s ability to locate binding sites. While it was designed to handle
low coverage data it works better with genomes that are larger than the 
2Mb we will simulate here. Also note that this simulation is somewhat simplistic
and is used here for demonstration purposes only. If we were interested in carrying 
out a serious simulation study for ChIP-seq data  we could use a more sophisticated 
approach\footnote{The \texttt{ChIPsim} package available from Bioconductor
provides functionality for this as does the simulation of Zhang~\emph{et al.} (2008)
available at \href{http://www.gersteinlab.org/proj/chip-seq-simu}{\url{www.gersteinlab.org/proj/chip-seq-simu}}}
but this will be sufficient to demonstrate the basic use of \texttt{ChIPseqR}.

The first step in our simple simulation is to define some nucleosome positions. We
will assume that the distance between the centres of adjacent nucleosomes lies
between 170 and 300~bp and follows a negative binomial distribution with mean 200.
In addition we will allow nucleosomes to be missing, introducing a gap of 400~bp
between adjacent nucleosomes.
Here we generate the distances between nucleosomes and translate them into nucleosome
positions:
<<distances>>=
	set.seed(1)
	dist <- sample(c(170:300, 400), 10100, prob=c(dnbinom(0:130, mu=30, size=5), 0.2), replace=TRUE)
	pos <- cumsum(dist)
	pos <- pos[pos < 2e6 - 200]
@
Now we generate read positions relative to binding sites. For this purpose we will make
a number of simplifying assumptions: 
\begin{enumerate}
\item Reads fall within 15~bp of either end of a nucleosome (with forward strand reads preceding the 
binding site and reverse strand reads following it);
\item Reads may be located up to 5~bp inside the binding site;
\item Read positions within these 20~bp are uniformly distributed;
\item The same number of forward and reverse strand reads are produced;
\item All nucleosomes cover exactly 147~bp;
\item Nucleosome positions are fixed;
\item Non-specific background reads are uniformly distributed throughout the genome. 
\end{enumerate}
Note that these assumptions are not used for the analysis and are not made by \texttt{ChIPseqR}, 
they just simplify the simulation.

We start by identifying all potential start positions for binding site related reads.  
<<readPos1>>=
	fwdRegion <- unlist(lapply(pos, function(x) (x-88):(x-68)))
	revRegion <- unlist(lapply(pos, function(x) (x+68):(x+88)))
@
Then we sample 50,000 reads from each strand. This should give us an
average of five reads per nucleosome and strand, not a lot of coverage.
<<readPos2>>=
	fwd <- sample(fwdRegion, 5e4, replace=TRUE)
	rev <- sample(revRegion, 5e4, replace=TRUE)
@
Finally we add 200,000 non-specific background reads to each strand. That is a lot of 
background noise so finding the nucleosomes will not be easy. 
<<readPos3>>=	
	fwd <- c(fwd, sample(25:(2e6-25), 2e5, replace=TRUE))
	rev <- c(rev, sample(25:(2e6-25), 2e5, replace=TRUE))
@

At this stage \texttt{fwd} and \texttt{rev} contain all positions of forward and
reverse strand reads. The final step in our simulation is to organise the
read position in a data frame that can then serve as input for \texttt{ChIPseqR}.
<<formatData>>=
	reads <- data.frame(chromosome="chr1", position=c(fwd, rev), length=25, 
			strand=rep(c("+", "-"), each=250000))
@

\section{Using \texttt{simpleNucCall}}
<<library>>=
	library(ChIPseqR)
@
The easiest way to predict nucleosome positions with \texttt{ChIPseqR} is to call
\texttt{simpleNucCall} with mapped reads. Here we will use the data frame created 
above but for real data it is usually more convenient to read the data into an
\texttt{AlignedRead} object using the functionality provided by the \texttt{ShortRead}
package. It is possible to simply pass the name of a file containing 
the mapped reads to \texttt{simpleNucCall} and they will be read in before the analysis.
Here we first convert the read positions into read counts so that we can use the
read counts again later. If we were not interested in inspecting the read counts later on
we could just pass the data frame to \texttt{simpleNucCall}
which would convert it into read counts for us.
<<simple>>=
	counts <- strandPileup(reads, chrLen=2e6, extend=1, plot=FALSE)
	nucs <- simpleNucCall(counts, bind=147, support=15, plot=FALSE)
@
Note the parameters in the above call. We specify the length of the binding and 
support regions as well as the chromosome length. The values chosen for binding
and support region length do not match the values in the simulation perfectly 
(where they are 137 and 20 respectively). Below we will discuss briefly how these
parameters can be estimated from the data. It is possible to obtain some diagnostic
plots by setting \texttt{plot = TRUE}.

Diagnostic plots can also be obtained later by plotting the R objects created by 
\texttt{strandPileup} and \texttt{simpleNucCall}. For example, to genarate some diagnostic 
plots to assess how well the data fits the null distribution used by
\texttt{ChIPseqR} we can simply plot \texttt{nucs}:
<<plotNucPrint, eval=FALSE>>=
	plot(nucs, type="density")
	plot(nucs, type="qqplot")
@
\begin{figure}[!thb]
\centering
<<plotNuc, fig=TRUE, echo=FALSE, width=10, height=5>>=
	par(mfrow=c(1,2))
	plot(nucs, type="density")
	plot(nucs, type="qqplot")
@
\caption{Diagnostic plots to assess fit of null distribution to observed binding site scores. 
The blue line marks the chosen significance cut-off.}
\end{figure}
The output is shown in Figure~1. The heavy right tail expected in the presence of nucleosomes in the 
sample is clearly visible. There is also some evidence that \texttt{ChIPseqR} overestimated the
variance of the null distribution. As a result of this $p$-values computed from this fit
will be conservative.

Here we have identified \Sexpr{length(nucs)} binding sites. Clearly some are missing
but that is to be expected considering the relatively low coverage and high noise level.
We can plot some of the data together with the binding site score and predicted
nucleosome positions using \texttt{plotWindow}:
<<plotWindowPrint, eval=FALSE>>=
	predicted <- peaks(nucs)[[1]][911]
	plot(counts, chr="chr1", center=predicted, score=nucs, width=1000, type="window")
@
The output is shown in Figure~2. Note how we use \texttt{peaks} to obtain a list of
predicted binding sites. To see how these predictions relate to the actual position 
of simulated nucleosomes we add some additional markers.
<<plotWindowPrint2, eval=FALSE>>=
	abline(v=pos[pos < predicted + 1000 & pos > predicted - 1000], col=3, lty=3)
@
\begin{figure}[htb]
\centering
<<plotWindow, fig=TRUE, echo=FALSE>>=
	predicted <- peaks(nucs)[[1]][911]
	plot(counts, chr="chr1", center=predicted, score=nucs, width=1000, type="window")
	abline(v=pos[pos < predicted + 1000 & pos > predicted - 1000], col=3, lty=3)
@
\caption{Read counts and predicted binding sites. Read counts on forward (red) and 
reverse (blue) strand are shown as vertical bars. The binding site score is shown in green with
green boxes at the bottom indicating predicted nucleosome positions. The true position of
simulated nucleosomes is indicated by vertical green lines.}
\end{figure}
As we can see in Figure~2 some nucleosome predictions overlap. These correspond to alternative
positions of the same nucleosome. On real data this may indicate variations in the actual nucleosome 
position observed in the sample or simply uncertainty due to low coverage, high noise level
or inaccurate choices of parameters. We can easily obtain non-overlapping predictions:
<<noOver>>=
	calls <- peaks(nucs)[[1]][c(1,which(diff(peaks(nucs)[[1]]) >= 170)+1)]
	length(calls)
@
Of course we would like to know how many of these are near actual nucleosome positions.
<<spec>>=
	table(sapply(calls, function(x) any((x-20):(x+20) %in% pos)))
@
Of the 118 apparent false positives 76 are within 30~bp of a simulated nucleosome. 

\section{Some details on \texttt{callBindingSites}}
Now that we have seen how to obtain binding site predictions it is time to take 
a closer look at how they are produced. Above we used \texttt{simpleNucCall}
to identify nucleosome positions. The actual work required to locate binding
sites is carried out by \texttt{callBindingSites}. The process of locating 
binding sites is divided into several stages:
\begin{enumerate}
\item Estimate length of binding and support region (if required);
\item Calculate binding site score;
\item Determine significance threshold;
\item Locate significant peaks in binding site score.
\end{enumerate}
In this section we will take a closer look at these different stages to get
a better understanding of how binding sites are identified and briefly introducing
the functions used for each stage.

\subsection{Estimating parameters}
In practice it may not always be
obvious what the best choice of parameters is. It is possible to get estimates for 
both parameters from the data by considering the cross-correlation between the read
counts on the forward and reverse strand. The function \texttt{getBindLen} is provided
for this purpose. However, it may not always produce good results. The approach taken
in \texttt{getBindLen} is to identify the first two peaks in cross-correlation and 
to derive values for binding and support region length consistent with the location
of these peaks. One of the main underlying assumptions is that the distribution of 
read counts in the support region is symmetric about the centre of the support region 
and the accuracy of results depends largely on how well this assumption holds. 
It is also possible to supply one parameter and estimate the other which can improve 
results substantially if the supplied parameter value is accurate. It should also be
noted that binding sites are assumed to occur in regular intervals and that they are
located relatively close to each other. This may be approximately true for nucleosomes
but does not hold for other proteins of interest.

Here is an example of how we might use \texttt{getBindLen} to estimate the parameters
for our simulated data.
\begin{figure}[htb]
\centering
<<getBindLen,fig=TRUE, echo=FALSE>>=
	bLen <- getBindLen(counts, bind = c(100,200), support = c(5, 50))
@
\caption{Cross-correlation between reads on forward and reverse strand used to estimate length
of binding and support regions.}
\end{figure}
<<getBindLenPrint, eval=FALSE>>=
	bLen <- getBindLen(counts, bind = c(100,200), support = c(5, 50))
@

This tells \texttt{getBindLen} to look for peaks in the cross-correlation that 
correspond to a binding region length between 100 and 200~bp and a support region
length between 5 and 50~bp. The resulting estimates are \Sexpr{bLen[1]}~bp for the 
binding region and \Sexpr{bLen[2]}~bp for the support regions. Since we know that the
correct answer should be 137 and 20~bp respectively it is clear that this is not perfect.

To use this parameter estimation method as part of the binding site prediction we can
simply pass \texttt{bind = c(100,200)} and \texttt{support = c(5, 50)} as arguments to
\texttt{callBindingSites} (or \texttt{simpleNucCall}).

\subsection{Scoring binding sites}
During this step the read counts are scanned along the genome and each position is assigned
a score indicating how likely it is to be the centre of a binding site. This involves
a sliding window partitioned into three regions, the binding region in the centre and
forward and reverse strand support regions on either side. Read counts in each region 
are compared to a background estimate obtained from a larger window (the default is 2000~bp).
A score is calculated for each region, with larger scores indication increasing departure
from the background distribution, and these are then combined into a binding site score.
The necessary computations are carried out by a call to \texttt{startScore}.
Further parameters used here are \texttt{bgCutoff} and \texttt{supCutoff}. They can be used
to limit the change in the estimate for adjacent background windows and between forward and
reverse support regions. These parameters should be chosen between 0.5 and 1. Lower values 
correspond to a more restrictive cut-off. Setting \texttt{bgCutoff = 0.5} will essentially 
force the use of a uniform background (which is not recommended) while \texttt{bgCutoff = 1} 
allows arbitrarily large changes in background estimates. The cut-off for support regions
works in a similar way. Generally lower cut-off values reduce the model's ability to adapt
to changes in local coverage while larger values make it more sensitive to artificially
large read counts observed in some locations.

\subsection{Determining significance}
Once binding site scores are calculated an attempt is made to assess their significance by
estimating the parameters of the null distribution. To achieve this a (truncated) normal 
distribution is fitted to the left tail of the observed scores. This assumes that low scores 
are largely unaffected by the presence of binding sites. Computations carried out by
\texttt{getCutoff} produce a binding site score cut-off corresponding to the requested
false discovery rate and the parameters of the fitted null distribution.

\subsection{Peak calling}
During the final stage of the analysis significant peaks in the binding site score are
identified and reported as predicted binding sites by \texttt{pickPeak}. This simply identifies
all peaks that exceed the threshold determined in the previous step and identifies the location
of the maximum of each peak as a binding site. Note that this may produce overlapping binding
site predictions if two such peaks are located close to each other. By default peaks have to be 
seperated by at least one value below the threshold but in some cases, e.g. when peaks are 
relatively wide compared to the length of a binding site, we may want to relax this requirement
such that peaks can be separated by a relatively low scoring region even if the score does not
drop below the threshold. This can be achieved by using \texttt{sub = TRUE}.

\section{Beyond nucleosomes}
Although \texttt{ChIPseqR} has been designed to locate nucleosomes it should be possible to 
apply the same approach to other types of ChIP-seq experiments. The most obvious way to adjust
\texttt{ChIPseqR} to different experiments is through the choice of binding and support region
length. These relate to the physical length of the binding site and the length of DNA fragments.
Generally a shorter binding site will require a shorter binding region but the best choice for 
this parameter also depends on the experimental protocol used. If DNA is sonicated it may be useful
to further reduce the length of the binding region while increasing the length of support regions.
Longer support regions will be required if the binding site is short compared to the fragment length.
 
\section{Internal data representation}
To reduce memory requirements the internal representation of read counts is compressed through
run-length encoding. In some cases this can lead to an increase in required memory. Should this
be the case for a particular dataset we can disable compression by calling \texttt{strandPileup}
with \texttt{compress = FALSE}. If we just want to obtain an expanded representation of
an already existing \texttt{ReadCounts} object we can use \texttt{decompress}:
<<decompress>>=
	counts2 <- decompress(counts)
@
In this case the decompressed representation is \Sexpr{sprintf("%.1f",object.size(counts2)/object.size(counts))}
times larger than the compressed one. For real datasets this factor can be substantially larger,
especially when coverage is low.

A similar approach is used to compress the binding site score. Since the score is a floating point value
a step function approximation is used to achieve better compression. This involves rounding
the calculated score to a certain number of digits. The use of fewer digits will improve
compression but also results in the loss of information and may affect results. The level
of compression can be set by passing argument \texttt{digits} to \texttt{callBindingSite} or 
\texttt{simpleNucCall}. The default is 16 which results in low compression but retains the
relevant information. The scoring method used by \texttt{ChIPseqR} is likely to produce missing
values, especially in regions of low coverage. This can result in relatively long runs of 
\texttt{NA}'s that are always compressed. Again it is possible to expand the representation
of binding site scores through a call to \texttt{decompress}. Note however that information
that was lost during compression can only be restored through recalculating binding site scores
at a lower compression setting. It is also possible to compress an expanded representation
of read counts or binding site scores through a call to \texttt{compress}.

\section{Session info}
<<sessionInfo>>=
	sessionInfo()
@

 
\end{document}

\name{plot-BindScore}
\alias{plot,BindScore,missing-method}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Diagnostic Plots for Binding Site Scores 
}
\description{
Generates plots to assess the fit of the estimated null distribution.
}
\usage{
\S4method{plot}{BindScore,missing}(x, npoints = 10000, type=c("density", "qqplot"), ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
	An object of class \code{\linkS4class{BindScore}}.
}
  \item{npoints}{
	Maximum number of points to plot in a QQ-plot.
}
   \item{type}{
	Character string indicating the plot type.  
}
  \item{\dots}{
 Further arguments (currently ignored).
}
}
\details{
Type \sQuote{density} produces a histogram of binding site scores with overlaid null distribution.
Type \sQuote{qqplot} produces a normal QQ-plot comparing the observed binding site scores to the 
null distribution.
}
\value{
Called for its side effect.
}

\author{
Peter Humburg
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{hplot}

\name{windowCounts}
\alias{windowCounts}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Summarize read counts in a sliding window}
\description{
  Read counts are summarized in a sliding window of variable size with variable overlap between windows.
}
\usage{
windowCounts(reads, window = 1000, shift = 500, method = sum)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{reads}{Numeric vector of read counts.}
  \item{window}{Width of window.}
  \item{shift}{Distance between consecutive window start positions.}
  \item{method}{Function used to produce a summary for each window. It should accept a single numeric vector as argument.}
}

\value{
  If \code{method} returns a single value a vector of all window summaries is returned, otherwise
  the return value is a list with one component for each window.
}
\author{Peter Humburg}

\examples{
## generate some very simple artificial read data
set.seed(1)
fwd <- sample(c(50:70, 250:270), 30, replace=TRUE)
rev <- sample(c(197:217, 347:417), 30, replace=TRUE)
## create data.frame with read positions as input to strandPileup
reads <- data.frame(chromosome="chr1", position=c(fwd, rev), 
	length=25, strand=factor(rep(c("+", "-"), times=c(30, 30))))

## create object of class ReadCounts
readPile <- strandPileup(reads, chrLen=501, extend=1, plot=FALSE, compress=FALSE)

## get number of reads in sliding window
wdwCount <- windowCounts(apply(readPile[[1]], 1, sum), window=10, shift=5)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{misc}

\name{ChIPseqR-package}
\alias{ChIPseqR-package}
\alias{ChIPseqR}
\docType{package}
\title{
Identifying Protein Binding Sites in High-Throughput Sequencing Data
}
\description{
ChIPseqR provides a set of functions for the analysis of ChIP-seq data. Protein binding sites
are located by identifying a characteristic pattern of peaks in read counts on both DNA strands.  
}
\details{
\tabular{ll}{
Package: \tab ChIPseqR\cr
Type: \tab Package\cr
Version: \tab 1.13.1\cr
Date: \tab 2012-12-11\cr
License: \tab GPL (>=2)\cr
LazyLoad: \tab yes\cr
}

The easiest way to obtain binding site predictions for nucleosomes is to use \code{\link{simpleNucCall}}. This provides
a simple interface to \code{\link{callBindingSites}}. This function operates on \code{\link[ShortRead:AlignedRead]{AlignedRead}} 
objects and provides useful defaults for nucleosome analysis. Parameters can be adjusted to detect the presence of other 
DNA binding proteins, e.g. transcription factors. If more fine control is desired the following steps will produce binding site 
predictions:
\describe{
\item{\code{\link{strandPileup}}:}{Turn mapped reads into read counts along the genome.}
\item{\code{\link{startScore}}:}{Score potential binding sites.}
\item{\code{\link{getCutoff}}:}{Determine cutoff required to achieve desired false discovery rate.}
\item{\code{\link{pickPeak}}:}{Find all peaks in the binding site score that exceed the significance 
	threshold determined by \code{getCutoff}. These are the predicted binding sites.}  
}
}
\author{
Peter Humburg

Maintainer: Peter Humburg <Peter.Humburg@well.ox.ac.uk>
}
\references{
Humburg, P., Helliwell, C., Bulger, D. & Stone, G. ChIPseqR: Analysis of ChIP-seq Experiments. BMC Bioinformatics 12, 39+ (2011).
}

\keyword{ package }
\seealso{
\code{\link[ShortRead:ShortRead-package]{ShortRead}}
}
\examples{
	## See 'simpleNucCall' for examples of how to obtain nucleosome predictions. 
}

\name{alignFeature}
\alias{alignFeature}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Read counts relative to annotated features}
\description{
  Creates a set of (strand specific) read counts centred at the genomic features provided. 
}
\usage{
alignFeature(data, anno, offset = 1000)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{data}{List with read counts as returned by \code{\link{strandPileup}}.}
  \item{anno}{Data frame with annotation data in GFF format.}
  \item{offset}{Half width of window around start point of annotated features.}
}
\value{
  List with one component for each feature in \code{anno}. 
}
\references{The GFF file format specification: http://www.sanger.ac.uk/Software/formats/GFF/GFF_Spec.shtml}
\author{Peter Humburg}

\examples{
set.seed(1)

## determine binding site locations
b <- sample(1:8.5e5, 500)

## sample read locations
fwd <- unlist(lapply(b, function(x) sample((x-83):(x-73), 20, replace=TRUE)))
rev <- unlist(lapply(b, function(x) sample((x+73):(x+83), 20, replace=TRUE)))

## add some background noise
fwd <- c(fwd, sample(1:(1e6-25), 5000))
rev <- c(rev, sample(25:1e6, 5000))

## create data.frame with read positions as input to strandPileup
reads <- data.frame(chromosome="chr1", position=c(fwd, rev), 
	length=25, strand=factor(rep(c("+", "-"), times=c(15000, 15000))))

## create object of class ReadCounts
readPile <- strandPileup(reads, chrLen=1e6, extend=1, plot=FALSE)

## convert binding site locations into GFF format
gff <- data.frame(chromosome="chr1", source="test", feature="binding", start=b-73, end=b+73, 
	score=".", strand=".", frame=".")

## align read counts relative to binding site location
aligned <- alignFeature(readPile, gff, offset=500)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{misc}

\name{ReadCounts-class}
\Rdversion{1.1}
\docType{class}
\alias{ReadCounts-class}
\alias{[<-,ReadCounts,ANY,missing-method}
\alias{[,ReadCounts,ANY,missing,missing-method}
\alias{[<-,ReadCounts,ANY,missing,ANY-method}
\alias{[[<-,ReadCounts,ANY,missing-method}
\alias{[[<-,ReadCounts,ANY,missing,ANY-method}
\alias{[[,ReadCounts,ANY,missing-method}
\alias{$<-,ReadCounts-method}
\alias{$<-,ReadCounts,ANY-method}
\alias{$,ReadCounts-method}
\alias{lapply,ReadCounts-method}
\alias{length<-,ReadCounts-method}
\alias{length,ReadCounts-method}
\alias{names<-,ReadCounts,ANY-method}
\alias{names,ReadCounts-method}
\alias{sapply,ReadCounts-method}
\alias{nreads,ReadCounts-method}
\alias{chrLength,ReadCounts-method}
\alias{ReadCounts}
\alias{nreads}
\alias{chrLength}

\title{Class "ReadCounts"}
\description{Represents counts of (possibly extended) reads for each strand of the genome.}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{ReadCounts(counts, names, compress=FALSE)} or by calls
to \code{\link{strandPileup}}.
}
\section{Slots}{
	 \describe{
    \item{\code{counts}:}{Object of class \code{"list"} with one component per chromosome, containing a matrix of read counts (one column per strand).}
  }
}
\section{Methods}{
  \describe{
    \item{[<-}{\code{signature(x = "ReadCounts", i = "ANY", j = "missing")}: Replace read counts for chromosomes indicated by \code{i}. }
    \item{[}{\code{signature(x = "ReadCounts", i = "ANY", j = "missing", drop = "missing")}: Returns list of read counts for chromosomes indicated by \code{i}.}
    \item{[[<-}{\code{signature(x = "ReadCounts", i = "ANY", j = "missing")}: Replace read counts for chromosome \code{i}.}
    \item{[[}{\code{signature(x = "ReadCounts", i = "ANY", j = "missing")}: Returns read counts for chromosome \code{i}.}
    \item{$<-}{\code{signature(x = "ReadCounts")}: Replace read counts for chromosome \code{i} (by name).}
    \item{$}{\code{signature(x = "ReadCounts")}: Returns read counts for chromosome \code{i} (by name).}
    \item{callBindingSites}{\code{signature(data = "ReadCounts")}: Predict bindingsites from read counts.}
    \item{chrLength}{\code{signature(x = "ReadCounts", subset = "ANY")}: Returns length of all chromosomes represented in \code{x}.}
    \item{lapply}{\code{signature(X = "ReadCounts")}: Apply function to read counts for each chromosome.}
    \item{length<-}{\code{signature(x = "ReadCounts")}: Change the number of chromosomes represented by \code{x} to \code{value}.}
    \item{length}{\code{signature(x = "ReadCounts")}: Number of chromosomes represented by \code{x}.}
    \item{names<-}{\code{signature(x = "ReadCounts", value = "ANY")}: Change names of chromosomes.}
    \item{names}{\code{signature(x = "ReadCounts")}: Chromosome names.}
    \item{nreads}{\code{signature(x = "ReadCounts", byStrand = "Logical", subset = "ANY")}: Returns the number of reads on each chromosome, split by strand (if \code{byStrand} is \code{TRUE}).}
    \item{sapply}{\code{signature(X = "ReadCounts")}: Apply function to read counts for each chromosome.}
	 }
}
\usage{
ReadCounts(counts=list(), names=NULL, compress=TRUE)
}
\arguments{
\item{counts}{A list of read counts. Each component is a two column matrix of strand specific read counts for a chromosome.}
\item{names}{Character vector of chromosome names. If this is \code{NULL} the names of \code{counts} are used instead.}
\item{compress}{Logical indicating whether read counts should be compressed.}
}
\author{Peter Humburg}

\seealso{
	\code{\linkS4class{BindScore}}, \code{\link{strandPileup}} , \code{\link[ChIPseqR:compress-ReadCounts]{compress}}, \code{\link{decompress}}
}
\examples{
showClass("ReadCounts")

## generate some very simple artificial read data
set.seed(1)
fwd <- sample(c(50:70, 250:270), 30, replace=TRUE)
rev <- sample(c(197:217, 347:417), 30, replace=TRUE)
## create data.frame with read positions as input to strandPileup
reads <- data.frame(chromosome="chr1", position=c(fwd, rev), 
	length=25, strand=factor(rep(c("+", "-"), times=c(30, 30))))

## create object of class ReadCounts
readPile <- strandPileup(reads, chrLen=500, extend=1, plot=FALSE, compress=FALSE)

names(readPile)
length(readPile)
sapply(readPile, sum)

}
\keyword{classes}

\name{compress-BindScore}
\alias{compress-BindScore}
\alias{compress,BindScore-method}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Compress BindScore Objects
}
\description{
Generates a compressed representation of binding site scores.
}
\usage{
\S4method{compress}{BindScore}(x, digits=16)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
	An object of class \code{\linkS4class{BindScore}}.
}
  \item{digits}{
	Integer indicating the number of decimal places to retain.
}
}
\details{
Binding site scores are compressed by first rounding them to \code{digits} decimal
places and then applying run-length encoding. 
}
\value{
An object of class \code{\linkS4class{RLEBindScore}}.
}

\author{
Peter Humburg
}
\note{
	Compression reduces the precision of binding site scores and may affect results, especially for small values
	of \code{digits}.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\linkS4class{Rle}}, \code{\linkS4class{RleList}}, \code{\link{compress-BindScore}}
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{utilities}

\name{compress-methods}
\docType{methods}
\alias{compress}
\alias{compress-methods}
\alias{compress,RLEBindScore-method}
\alias{compress,RLEReadCounts-method}
\title{Methods for Function compress in Package `ChIPseqR'}
\description{
 Methods to obtain compressed versions of data structures. 
}
\section{Methods}{
\describe{

\item{\code{signature(x = "BindScore")}}{Converts \code{x} into an object of class \code{\linkS4class{RLEBindScore}}.}

\item{\code{signature(x = "ReadCounts")}}{Converts \code{x} into an object of class \code{\linkS4class{RLEReadCounts}}.}

\item{\code{signature(x = "RLEBindScore")}}{Returns (the already compressed) \code{x}.}

\item{\code{signature(x = "RLEReadCounts")}}{Returns (the already compressed) \code{x}.}
}}
\keyword{methods}

\name{RLEReadCounts-class}
\Rdversion{1.1}
\docType{class}
\alias{RLEReadCounts-class}
\alias{chrLength,RLEReadCounts-method}
\alias{nreads,RLEReadCounts-method}

\title{Run-length Encoded Read Counts}
\description{This class provides a memory efficient representation of strand specific read counts.}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{ReadCounts(counts, names, compress = TRUE)} or by calls
to \code{\link{strandPileup}}. 
}
\section{Slots}{
  \describe{
    \item{\code{counts}:}{Object of class \code{"list"} with one component per chromosome, 
    containing a read counts encoded in an object of class \code{\linkS4class{RleList}}.}
  }
}
\section{Extends}{
Class \code{"\linkS4class{ReadCounts}"}, directly.
}
\section{Methods}{
  \describe{
    \item{chrLength}{\code{signature(x = "RLEReadCounts")}: Returns length of all chromosomes represented in \code{x}.}
%    \item{compress}{\code{signature(x = "RLEReadCounts")}: }
    \item{decompress}{\code{signature(x = "RLEReadCounts")}: Expands read counts and returns object of class \code{\linkS4class{ReadCounts}}.}
    \item{nreads}{\code{signature(x = "RLEReadCounts")}: Returns the number of reads on each chromosome, split by strand (if \code{byStrand} is \code{TRUE})}
    \item{plot}{\code{signature(x = "RLEReadCounts", y = "missing")}: Generates plots of read counts.}
	 }
}
\author{Peter Humburg}

\seealso{
	\code{\linkS4class{ReadCounts}}, \code{\linkS4class{RleList}}  
}
\examples{
showClass("RLEReadCounts")

## generate some very simple artificial read data
set.seed(1)
fwd <- sample(c(50:70, 250:270), 30, replace=TRUE)
rev <- sample(c(197:217, 347:417), 30, replace=TRUE)
## create data.frame with read positions as input to strandPileup
reads <- data.frame(chromosome="chr1", position=c(fwd, rev), 
	length=25, strand=factor(rep(c("+", "-"), times=c(30, 30))))

## create object of class ReadCounts
readPile <- strandPileup(reads, chrLen=500, extend=1, plot=FALSE, compress=TRUE)

names(readPile)
length(readPile)
sapply(readPile, sum)
}
\keyword{classes}

\name{simpleNucCall}
\alias{simpleNucCall}
%- Also NEED an '\alias' for EACH other topic documented here.
		\title{Predict nucleosome positions from high-throughput sequencing data}
\description{
	This function provides a simplified interface to \code{\link{callBindingSites}} with defaults suitable for
	the detection of nucleosomes.
}
\usage{
	simpleNucCall(data, bind=128, support=17, background=2000, chrLen, ...)
}
%- maybe also 'usage' for other objects documented here.
		\arguments{
			\item{data}{Either an object of class \code{\link[ShortRead:AlignedRead]{AlignedRead}} or a list. See below for details.}
			\item{bind}{Length of binding region to use (see Details).}
			\item{support}{Length of support region to use (see Details).}
			\item{background}{Length of background window. If this is missing it will be set to 10*(\code{bind}+2*\code{support}).}
			\item{chrLen}{Numeric vector indicating the length of all chromosomes. Only needed when 
				\code{data} is an \code{\link[ShortRead:AlignedRead]{AlignedRead}} object. \code{\link[ShortRead:readBfaToc]{readBfaToc}} 
				may be used to supply this information.}
			\item{...}{Further arguments to \code{\link{callBindingSites}}}
		}

\value{
	A \code{list} with components
	\item{binding}{A \code{data.frame} with columns \sQuote{chromosome}, \sQuote{position}, \sQuote{score} and \sQuote{pvalue}
		indicating the centre of predicted binding sites together with their score and associated p-value.}
	\item{score}{A \code{list} with all calculated scores. One numeric vector per chromosome.}
	\item{pval}{A \code{list} with all corrected p-values. One numeric vector per chromosome.}
}
\references{ ~put references to the literature/web site here ~ }
\author{Peter Humburg}

\seealso{\code{\link{callBindingSites}} for additional parameters.}
\examples{
## generate some simple artificial read data
set.seed(1)

## determine binding site locations
b <- sample(1:1e6, 5000)

## sample read locations
fwd <- unlist(lapply(b, function(x) sample((x-83):(x-73), 20, replace=TRUE)))
rev <- unlist(lapply(b, function(x) sample((x+73):(x+83), 20, replace=TRUE)))

## add some background noise
fwd <- c(fwd, sample(1:(1e6-25), 50000))
rev <- c(rev, sample(25:1e6, 50000))

## create data.frame with read positions as input to strandPileup
reads <- data.frame(chromosome="chr1", position=c(fwd, rev), 
	length=25, strand=factor(rep(c("+", "-"), times=c(150000, 150000))))

## create object of class ReadCounts
readPile <- strandPileup(reads, chrLen=1e6, extend=1, plot=FALSE)

## predict binding site locations
bindScore <- simpleNucCall(readPile, bind=147, support=20, plot=FALSE)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
		% R documentation directory.
\keyword{models}
\keyword{htest}

\name{decompress}
\alias{decompress}
\alias{decompress,RLEBindScore-method}
\alias{decompress,RLEReadCounts-method}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Extract Read Count and Binding Site Score Representations 
}
\description{
These methods extract read count and binding site sores from compressed representations. 
}
\usage{
\S4method{decompress}{RLEReadCounts}(x)
\S4method{decompress}{RLEBindScore}(x)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
	An object of class \code{\linkS4class{RLEBindScore}} or \code{\linkS4class{RLEReadCounts}}.
}
}

\value{
An object of class \code{\linkS4class{BindScore}} or \code{\linkS4class{ReadCounts}} respectively.
}
\author{
Peter Humburg
}

\seealso{
\code{\link[=compress-methods]{compress}}
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{utilities}

\name{pos2gff}
\alias{pos2gff}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Convert genome coordinates into GFF format}
\description{
  Provides facility to export the location of genomic features to a GFF formatted file.
}
\usage{
pos2gff(pos, method, feature, len, strand, score, name)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{pos}{Named list with one component per chromosome giving the start position of features on that chromosome.}
  \item{method}{Entry for method field in GFF file. Recycled as necessary}
  \item{feature}{Entry for feature field in GFF file. Recycled as necessary}
  \item{len}{Length of fetures. This is used to calculate matching end positions for each start position given in \code{pos}}
  \item{strand}{Entry for feature field in GFF file. Recycled as necessary}
  \item{score}{Entry for feature field in GFF file. Recycled as necessary}
  \item{name}{Entry for feature field in GFF file. Recycled as necessary}
}
\value{
  A \code{data.frame} with columns \code{'chromosome'}, \code{'method'}, \code{'feature'}, \code{'start'}, 
  \code{'end'}, \code{'score'}, \code{'strand'}. Writing this data frame to a text 
  file produces a GFF formatted file.  
}
\references{The GFF specification: http://www.sanger.ac.uk/Software/formats/GFF/GFF_Spec.shtml}
\author{Peter Humburg}
\examples{
pos <- list(chr1=c(10, 50, 60), chr2=c(22, 200, 500))
pos2gff(pos, "test", "foo", 25, c("+", "+", "-", "+", "-", "-"), 0, "test")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{utilities}

\name{BindScore-class}
\Rdversion{1.1}
\docType{class}
\alias{BindScore-class}
\alias{as.data.frame,BindScore-method}
\alias{[,BindScore,ANY,missing,missing-method}
\alias{[[,BindScore,ANY,missing-method}
\alias{[[,BindScore,ANY,numeric-method}
\alias{binding,BindScore-method}
\alias{cutoff<-,BindScore-method}
\alias{cutoff,BindScore-method}
\alias{head,BindScore-method}
\alias{lapply,BindScore-method}
\alias{length<-,BindScore-method}
\alias{length,BindScore-method}
\alias{max,BindScore-method}
\alias{min,BindScore-method}
\alias{names<-,BindScore,ANY-method}
\alias{names,BindScore-method}
\alias{nullDist,BindScore-method}
\alias{nullDist<-,BindScore-method}
\alias{peaks,BindScore-method}
\alias{range,BindScore-method}
\alias{score,BindScore-method}
\alias{support,BindScore-method}
\alias{tail,BindScore-method}
\alias{chrLength,BindScore-method}      
\alias{BindScore}               


\title{Class "BindScore"}
\description{This class provides the infrastructure to store results of ChIP-seq analysis.}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("BindScore", functionCall, score, pvalue, peaks, cutoff, nullDist, names, ...)}.
	 Objects of this class are typically created (and returned) by functions that perform
	 peak calling on ChIP-seq data. Usually there should be no need to create them directly. 
}
\section{Slots}{
	 \describe{
    \item{\code{functionCall}:}{Object of class \code{"call"} storing the function call used to initiate the analysis.}
    \item{\code{score}:}{Object of class \code{"list"}. The binding site score. One numeric vector per chromosome.}
    \item{\code{pvalue}:}{Object of class \code{"list"}. The (adjusted) p-values corresponding to the scores in slot \code{score}.}
    \item{\code{peaks}:}{Object of class \code{"list"} giving the location of significant peaks in the binding site score. These correspond to the location of predicted binding sites.}
    \item{\code{cutoff}:}{Object of class \code{"numeric"} with entries \sQuote{pvalue} and \sQuote{score} giving the significance threshold used for peak calling in terms of p-value and score.}
    \item{\code{nullDist}:}{Object of class \code{"numeric"} providing the parameters of the null distribution used to determine p-values.}
    \item{\code{start}:}{Object of class \code{"integer"} indicating the index corresponding to the first entry in \code{score} (assumed to be the same for all chromosomes).}
  }
}
\section{Methods}{
  \describe{
    \item{as.data.frame}{\code{signature(x = "BindScore")}: Convert results into a \code{data.frame} giving the location, score and p-value of significant peaks.}
    \item{[}{\code{signature(x = "BindScore", i = "ANY", j = "missing", drop = "missing")}: Restrict results to a subset of chromosomes. Chromosomes can either be identified by name or by numerical index.}
    \item{[[}{\code{signature(x = "BindScore", i = "ANY", j = "missing")}: Restrict results to a single chromosome. Note that \code{x[["chr1"]]} is identical to \code{x["chr1"]}.}
    \item{[[}{\code{signature(x = "BindScore", i = "ANY", j = "numeric")}: subset results to restrict them to a region on a single chromosome.}
    \item{binding}{\code{signature(x = "BindScore")}: Returns length of binding site used during analysis.}
    \item{chrLength}{\code{signature(x = "BindScore", subset = "ANY")}: Returns length of all chromosomes represented in \code{x}.}
    \item{cutoff<-}{\code{signature(x = "BindScore")}: Sets the significance cut-off. Argument \code{type=c("score", "pvalue")} determines which cut-off is to be set, the other is adjusted accordingly. This recalculates the significance of peaks in the binding site score and may be slow.}
    \item{cutoff}{\code{signature(x = "BindScore")}: Returns significance threshold used for analysis.}
    \item{head}{\code{signature(x = "BindScore")}: Returns the first \code{n} peaks. Argument \code{by = c("score", "position")} determines whether results are sorted by score or by genomic location.}
    \item{lapply}{\code{signature(X = "BindScore")}: Applies a function to results for each chromosome.}
    \item{length<-}{\code{signature(x = "BindScore")}: Reduces the number of chromosomes for which results are stored, i.e., \code{length(x) <- 3} only retains the first three chromosomes.}
    \item{length}{\code{signature(x = "BindScore")}: Returns the number of binding sites identified by the analysis.}
    \item{max}{\code{signature(x = "BindScore")}: Returns maximum score.}
    \item{min}{\code{signature(x = "BindScore")}: Returns minimum score.}
    \item{names<-}{\code{signature(x = "BindScore", value = "ANY")}: Sets the chromosome names.}
    \item{names}{\code{signature(x = "BindScore")}: Returns the chromosome names.}
    \item{nullDist<-}{\code{signature(x = "BindScore")}: Sets the parameters of the null distribution adjusting the significance cut-off in the process and predicts binding sites using the new null distribution.}
    \item{peaks}{\code{signature(x = "BindScore")}: Returns list of predicted binding sites.}
    \item{range}{\code{signature(x = "BindScore")}: Range of binding site scores.}
    \item{score}{\code{signature(x = "BindScore")}: Returns list of binding site scores.}
    \item{support}{\code{signature(x = "BindScore")}: Returns length of support region used during analysis.}
    \item{tail}{\code{signature(x = "BindScore")}: Returns the last \code{n} peaks. Argument \code{by = c("score", "position")} determines whether results are sorted by score or by genomic location.}
	 }
}
\usage{
	\S4method{binding}{BindScore}(x)
	\S4method{chrLength}{BindScore}(x, subset)
	\S4method{cutoff}{BindScore}(x, type=c("score", "pvalue"))
	\S4method{cutoff}{BindScore}(x, type=c("score", "pvalue")) <- value
	\S4method{head}{BindScore}(x, n=6, by=c("score", "position"), ...)
	\S4method{lapply}{BindScore}(X, FUN, ...)
	\S4method{length}{BindScore}(x)
	\S4method{length}{BindScore}(x) <- value
	\S4method{max}{BindScore}(x, ..., na.rm=TRUE)
	\S4method{min}{BindScore}(x, ..., na.rm=TRUE)
	\S4method{names}{BindScore}(x)
	\S4method{names}{BindScore,ANY}(x) <- value
	\S4method{nullDist}{BindScore}(x)
	\S4method{nullDist}{BindScore}(x) <- value
	\S4method{peaks}{BindScore}(x, ...)
	\S4method{range}{BindScore}(x, ..., na.rm=TRUE)
	\S4method{score}{BindScore}(x)
	\S4method{support}{BindScore}(x)
	\S4method{tail}{BindScore}(x, n=6, by=c("score", "position"), ...)
	BindScore(call, score=list(), pvalue=list(), peaks=list(), cutoff=c(-Inf, 1), nullDist=c(0, 1), names=NULL, start=1L, compress=TRUE, digits=16)
}
\arguments{
	\item{x}{Object of class \code{BindScore}.}
	\item{X}{Object of class \code{BindScore}.}
	\item{subset}{Index vector indicating a subset of \code{x}. If \code{subset} is  missing everything is selected.}
	\item{type}{A string indicating which type of cut-off should be returned or changed. Either \code{"score"} or \code{"pvalue"}}
	\item{n}{Number of entries to show.}
	\item{by}{A string indicating whether the output should be sorted by score or by position in the genome.}
	\item{na.rm}{Logical indication whether \code{NA}s should be ignored.}
	\item{FUN}{Function to apply to results for each chromosome.}
	\item{value}{Replacement value.}
	\item{call}{Function call used to generate the values of the other slots.}
	\item{score}{List of binding site scores. One component per chromosome.}
	\item{pvalue}{List of binding site p-values. One component per chromosome.}
	\item{peaks}{List of significant peaks in binding site score. One component per chromosome.}
	\item{cutoff}{Numeric vector of length two indicating the significance cut-off in terms of score and p-value.}
	\item{nullDist}{Parameters of the null distribution.}
	\item{names}{Character vector providing names for chromosomes.}
	\item{start}{Integer indicating position of first binding site score.}
	\item{compress}{Logical indicating whether scores and p-values should be compressed.}
	\item{digits}{The number of decimal places to retain for compression.}
	\item{\dots}{Further arguments.}
}
\references{ ~put references to the literature/web site here ~ }
\author{Peter Humburg}

\seealso{
	\code{\linkS4class{ReadCounts}} for the data structure used as input for the analysis and \code{\link[=callBindingSites,ReadCounts-method]{callBindingSites}}
}
\examples{
showClass("BindScore")

set.seed(1)

## determine binding site locations
b <- sample(1:1e6, 5000)

## sample read locations
fwd <- unlist(lapply(b, function(x) sample((x-83):(x-73), 20, replace=TRUE)))
rev <- unlist(lapply(b, function(x) sample((x+73):(x+83), 20, replace=TRUE)))

## add some background noise
fwd <- c(fwd, sample(1:(1e6-25), 50000))
rev <- c(rev, sample(25:1e6, 50000))

## create data.frame with read positions as input to strandPileup
reads <- data.frame(chromosome="chr1", position=c(fwd, rev), 
	length=25, strand=factor(rep(c("+", "-"), times=c(150000, 150000))))

## create object of class ReadCounts
readPile <- strandPileup(reads, chrLen=1e6, extend=1, plot=FALSE)

## predict binding site locations
## the artificial dataset is very small so predictions may not be very reliable
bindScore <- simpleNucCall(readPile, bind=147, support=20, plot=FALSE, compress=FALSE)

## number of binding sites found
length(bindScore)

## the first few predictions, by score
head(bindScore)

## score and p-value cut-off used
cutoff(bindScore)

}
\keyword{classes}

\name{internal}
\Rdversion{1.1}
\alias{diNucTest}
\alias{allGroups}
\alias{allWords}
\alias{oligoNucTest}
\alias{triNucTest1}
\alias{triNucTest2}
\alias{views2nucFreq}
\alias{plotBind}
\alias{plotFreq}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Internal and undocumented functions
}
\description{
These functions for internal use or currently unsupported.
}
%\usage{
%
%}
%- maybe also 'usage' for other objects documented here.

%\details{
%%  ~~ If necessary, more details than the description above ~~
%}
%\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
%}
%\references{
%% ~put references to the literature/web site here ~
%}
\author{
Peter Humburg
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{internal}

\name{plotWindow}
\alias{.plotWindow}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Plot read counts within a genomic region}
\description{
  Read count within a selected region of the genome are plotted, optionally together 
  with binding site score and location of predicted binding sites.
}
\usage{
.plotWindow(data, chr, center, score, width=2000, bind, start, end, bind.col=3, score.type='l',	
	xlab=NULL, ylab="Read count", cutoff=TRUE, offset = 1, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{data}{Object of class \code{\linkS4class{ReadCounts}} or a list of read counts.}
  \item{chr}{A character string or numeric index identifying the the chromosome on which the region is located.}
  \item{center}{Numeric value giving the center of the region on chromosome \code{'chr'} that should be plotted.}
  \item{score}{An object of class \code{\linkS4class{BindScore}}, may be missing.}
  \item{width}{Width of the window to plot. The plotted region will be [center - width/2, center + width/2].}
  \item{bind}{Length of binding site, ignored if \code{'score'} is missing.}
  \item{start}{Start of plotting window (may be used together with \code{end} instead of \code{center}).}
  \item{end}{End of plotting window (may be used together with \code{start} instead of \code{center}).}
  \item{bind.col}{Color used to indicate location of binding sites, ignored if \code{'score'} is missing.}
  \item{score.type}{Plotting type to use for score, ignored if \code{'score'} is missing.}
  \item{xlab}{X-axis label. This defaults to a description of the genomic location constructed from \code{'chr'},
  \code{'center'} and \code{'width'}}
  \item{ylab}{Y-axis label.}
  \item{cutoff}{Logical indicating whether the significance threshold used to predict binding site locations 
  should be indicated by a horizontal line in the plot.}
  \item{offset}{Position on chromosome \code{chr} corresponding to the first read count in \code{data}.}
  \item{\dots}{Further arguments to \code{plot}.}
}
\details{
  If \code{'score'} is present the binding site score is plotted on top of read counts. Scores are rescaled
  to lie between 0 and the maximum number of reads in the window. A corresponding scale is added to the right 
  hand axis.
}
\value{
  Called for its side effect.
}
\author{Peter Humburg}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{hplot}
\keyword{internal}

\name{acessors}
\Rdversion{1.1}
\alias{peaks}
\alias{peaks-methods}                              
\alias{peaks,ANY-method}
\alias{pvalue}
\alias{pvalue-methods}                              
\alias{pvalue,ANY-method}
\alias{score}
\alias{cutoff}
\alias{cutoff-methods}                              
\alias{cutoff,ANY-method}
\alias{cutoff<-}
\alias{cutoff<--methods}                              
\alias{cutoff<-,ANY-method}
\alias{support}
\alias{support-methods}                              
\alias{support,ANY-method}
\alias{binding}
\alias{binding-methods}                              
\alias{binding,ANY-method}
\alias{nullDist}
\alias{nullDist-methods}                              
\alias{nullDist,ANY-method}
\alias{nullDist<-}
\alias{nullDist<--methods}                              
\alias{nullDist<-,ANY-method}


%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Access slots of S4 classes
}
\description{
Accessor functions for S4 classes in package \code{"ChIPseqR"}. 
}
\usage{
	\S4method{binding}{ANY}(x, ...)
	\S4method{cutoff}{ANY}(x, ...)
	\S4method{cutoff}{ANY}(x, ...) <- value
	\S4method{nullDist}{ANY}(x, ...)
	\S4method{nullDist}{ANY}(x, ...) <- value
	\S4method{peaks}{ANY}(x, ...)
	\S4method{pvalue}{ANY}(x, ...)
	\S4method{support}{ANY}(x, ...)
}
\section{Methods}{
\describe{                  
\item{x = "ANY"}{Default method for accessor function.}
}}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
An S4 object.
}
  \item{\dots}{
Further arguments, ignored by default method.
}
\item{value}{New value for slot.}
}
\details{
These methods allow safe read (and in some cases write) access to slots of S4 classes and should be used
for this purpose rather than modifying slots manually.
}
\value{
The current value of the interrogated slot.
}

\author{
Peter Humburg
}
\note{
This page documents the generics and their default behaviour. See the help page of each class for class 
specific implementations.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\linkS4class{ReadCounts}}, \code{\linkS4class{BindScore}}
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{utilities}

\name{pickPeak}
\alias{pickPeak}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Identify peaks above a given threshold}
\description{
  Given a vector of scores and a threshold, this function finds all peaks 
  that exceed the threshold.
}
\usage{
pickPeak(score, threshold, offset = 0, sub = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{score}{Numeric vector.}
  \item{threshold}{All values in \code{score} below this value are ignored.}
  \item{offset}{Offset to add to the determined peak locations.}
  \item{sub}{Logical. If this is \code{FALSE} (the default) for each region that exceeds the threshold
  only the global maximum is returned. Otherwise local maxima are returned as well.}
}

\value{
  If \code{sub = FALSE} a numeric vector giving the location of all peaks.
  Otherwise a list with components
  \item{peaks}{The same peak locations that are returned for \code{sub = FALSE}.}
  \item{subPeaks}{A list with one component for each entry in \sQuote{peaks} giving the location
  of local maxima.} 
}

\note{
This function is used by \code{\link{callBindingSites}} for peak-calling. 
}
\author{Peter Humburg}

\seealso{\code{\link{callBindingSites}}, \code{\link{startScore}}, \code{\link{getCutoff}}}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{misc}

\name{plotReads}
\alias{.plotReads}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Plot compact representation of read counts on a chromosome}
\description{
  Creates an image of all read counts for a chromosome.
}
\usage{
.plotReads(x, scale = c("total", "ratio"), log = TRUE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{A two column matrix with read counts (as produced by \code{\link{strandPileup}}).}
  \item{scale}{Character string indicating whether to plot the total number of reads on both strands or the ratio between them.}
  \item{log}{Logical indicating whether to use log read counts.}
  \item{\dots}{Further plotting arguments.}
}
\details{
 The read counts (or read count ratios) are plotted as a Hilbert curve using 
 \code{\link[HilbertVis:hilbertImage]{hilbertImage}}.
}
\value{
  Called for its side effect.
}
\references{\cite{Anders, Simon, 'Visualization of genomic data with the Hilbert curve',  Bioinformatics , vol. 25, no. 10, 1231-1235 (2009).}}
\author{Peter Humburg}

\seealso{\code{\link{strandPileup}}, \code{\link[HilbertVis:hilbertImage]{hilbertImage}}}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{hplot}
\keyword{internal}

\name{getCutoff}
\alias{getCutoff}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Determine significance threshold for binding site scores}
\description{
  Given a vector of observed binding site scores and a desired false discovery rate, this
  function returns the lowest score that should be considered significant to achieve the 
  given false discovery rate.
}
\usage{
getCutoff(score, alpha = 0.05, tailCut = 0.95, adapt = FALSE, lambda, plot = TRUE, returnPval = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{score}{Numeric vector with binding site scores.}
  \item{alpha}{Desired false discovery rate.}
  \item{tailCut}{Truncation point used to exclude outliers when fitting the null distribution.}
  \item{adapt}{Logical indicating whether an adaptive false discovery rate should be used.}
  \item{lambda}{If \code{adapt} is \code{TRUE} this is used in estimating the proportion of 
  scores that is unrelated to binding sites.}
  \item{plot}{If this is \code{TRUE} (the default) a plot of the observed score distribution
  and estimated null distribution is generated.}
  \item{returnPval}{Indicates whether or not the corrected p-values for all scores should be returned.}
}

\value{
  A list with components
  \item{cutoff}{A numeric vector with the score and nominal false discovery rate corresponding
  to the determined cutoff.}
  \item{h0}{A numeric vector with the mean and standard deviation of the estimated null distribution.}
  \item{pvalue}{If \code{returnPval} is \code{TRUE}, the p-values corresponding to the scores in \code{score}. 
  Note that all missing values are removed.}
  \item{pi0}{If \code{adapt} is \code{TRUE}, the estimated proportion of scores not related to binding sites.}
}

\note{
This function is used by \code{\link{callBindingSites}} to determine the significance threshold for
peak-calling.
}

\references{For the adaptive false discovery rate procedure used if \code{adapt=TRUE} see 
JD Storey, JE Taylor and D Siegmund. Strong control, conservative point
estimation and simultaneous conservative consistency of false discovery rates: a unified approach.
Journal of the Royal Statistical Society B, 66(1):187-205, 2004.
}

\author{Peter Humburg}

\seealso{\code{\link{callBindingSites}}}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{htest}

\name{decompress-methods}
\docType{methods}
\alias{decompress-methods}
\alias{decompress,ANY-method}
\alias{decompress,Rle-method}
\alias{decompress,RleList-method}

\title{Methods for Function decompress in Package `ChIPseqR'}
\description{
 Methods to extract compressed data structures.
}
\section{Methods}{
\describe{

\item{\code{signature(x = "ANY")}}{The default method simply returns \code{x}.}

\item{\code{signature(x = "Rle")}}{Restores the atomic vector encoded in \code{x}.}

\item{\code{signature(x = "RLEBindScore")}}{Returns an object of \code{\linkS4class{BindScore}}.}

\item{\code{signature(x = "RleList")}}{Extracts the components of \code{x} and restores them to atomic vectors.}

\item{\code{signature(x = "RLEReadCounts")}}{Returns an object of \code{\linkS4class{ReadCounts}}.}
}}
\keyword{methods}

\name{compress-ReadCounts}
\alias{compress,ReadCounts-method}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Compress ReadCount Objects
}
\description{
Generates a compressed representation of read counts. 
}
\usage{
\S4method{compress}{ReadCounts}(x)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
	An object of class \code{\linkS4class{ReadCounts}}
}

}
\details{
Run-length encoding is used to obtain a compressed representation of read counts. 
}
\value{
An object of class \code{\linkS4class{RLEReadCounts}}
}

\author{
Peter Humburg
}

\seealso{
\code{\linkS4class{Rle}}, \code{\linkS4class{RleList}}, \code{\link{compress-BindScore}}
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{utilities}

\name{strandPileup}
\alias{strandPileup-methods}
\alias{strandPileup,AlignedRead-method}
\alias{strandPileup,data.frame-method}
\alias{strandPileup}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Strand specific read counts}
\description{
  Given a set of aligned reads this function computes the number of reads
  starting at each position in the genome.
}
\usage{
\S4method{strandPileup}{AlignedRead}(aligned, chrLen, extend,  coords=c("leftmost", "fiveprime"),
		compress = TRUE, plot = TRUE, ask = FALSE, ...)
\S4method{strandPileup}{data.frame}(aligned, chrLen, extend, coords=c("leftmost", "fiveprime"), 
		compress = TRUE, plot = TRUE, ask = FALSE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{aligned}{An object containing information about aligned reads (see Details).}
  \item{chrLen}{A numeric vector giving the length of each chromosome.}
  \item{extend}{A numeric value indicating how far reads should be extended.}
  \item{coords}{A character value indicating the coordinate system to use. 
  See \code{\link[ShortRead:AlignedRead]{coverage}} for details.}
  \item{compress}{Logical indicating whether read counts should be compressed.}
  \item{plot}{If this is \code{TRUE} (the default) read coverage is plotted for all chromosomes.}
  \item{ask}{Logical. Setting this to \code{TRUE} causes the system to wait for user input before displaying a new plot.
  See \code{\link[grDevices:devAskNewPage]{devAskNewPage}}.}
  \item{\dots}{Further arguments to \code{\link[IRanges:coverage-methods]{coverage}}.}
}
\details{
  The method for \code{data.frame} requires the column names to follow a strict naming scheme. Required columns are
 \describe{
  \item{\sQuote{chromosome}}{A factor with chromosome names.}
  \item{\sQuote{strand}}{A factor with levels \dQuote{-} and \dQuote{+} indicating which strand the read mapped to.}
  \item{\sQuote{start} \bold{or} \sQuote{position}}{Start position of read on chromosome.}
  \item{\sQuote{end} \bold{or} \sQuote{length}}{End position of read or length of read respectively.}
  }
}

\value{
  An object of class \code{\linkS4class{ReadCounts}}.
}
\author{Peter Humburg}

\seealso{\code{\link[IRanges:coverage-methods]{coverage}}, \code{\link[ShortRead:AlignedRead]{AlignedRead}}, 
\code{\link{callBindingSites}}}
\examples{
	## generate some very simple artificial read data
	set.seed(1)
	fwd <- sample(c(50:70, 250:270), 30, replace=TRUE)
	rev <- sample(c(197:217, 347:417), 30, replace=TRUE)
	## create data.frame with read positions as input to strandPileup
	reads <- data.frame(chromosome="chr1", position=c(fwd, rev), 
		length=25, strand=factor(rep(c("+", "-"), times=c(30, 30))))
	
	readPile <- strandPileup(reads, chrLen=500, extend=1, plot=FALSE)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{utilities}

\name{getBindCor}
\alias{getBindCor}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Calculate cross-correlation between read counts}
\description{
  This function calculates the cross-correlation between read counts on forward and reverse strand.
}
\usage{
getBindCor(data, max.lag, summary, plot = TRUE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{data}{An object of class \code{\linkS4class{ReadCounts}}}
  \item{max.lag}{Maximum lag to use in cross-correlation calculation.}
  \item{summary}{Function to use to summarise cross-correlation across chromosomes.}
  \item{plot}{Logical indicating whether to plot cross-correlation.}
  \item{\dots}{Further arguments, currently ignored.}
}
\details{
 Function \code{\link[timsac:fftcor]{fttcor}} in package \dQuote{timsac} is used to carry out the computation.
}
\value{
 The (summarised) cross-correlation. If \code{summary} is missing a list of cross-correlations for
 each chromosome is returned.
}
\author{Peter Humburg}

\seealso{\code{\link[timsac:fftcor]{fftcor}}, \code{\linkS4class{ReadCounts}}, \code{\link{getBindLen}}}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{utilities}

\name{getBindLen}
\alias{getBindLen}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Estimate length of binding and support region}
\description{
  The cross-correlation between forward and reverse strand read counts is used to estimate the distance between
  peaks on both strands. This is then used to derive suitable values for the length of binding and support regions.
}
\usage{
getBindLen(data, bind, support, summary = median, verbose = FALSE, plot = TRUE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{data}{An object of class \code{\linkS4class{ReadCounts}}.}
  \item{bind}{Either known length of binding region or minimum and maximum of binding region length to consider.}
  \item{support}{Either known length of support region or minimum and maximum of support region length to consider.}
  \item{summary}{Function to use to summarise cross-correlation across chromosomes.}
  \item{verbose}{Logical indicating whether progress messages should be printed.}
  \item{plot}{Logical indicating whether cross-correlation should be plotted.}
  \item{\dots}{Further arguments to \code{\link{getBindCor}}.}
}
\details{
 This assumes that the first peak in cross-correlation corresponds to the length of the binding site.
 Note that this is not accurate. The peak is closer to bind + 2*m where m is the median of the 
 read distribution in the support region ('read distribution in the support region' means the read 
 density as a function of distance to binding site start/end). Consequently this method will 
 overestimate the length of the binding site. If either bind or support are of length 1 
 this is assumed to be the known value and a more accurate estimate for the remaining parameter is used.
}
\value{
  A numeric vector giving the estimated lengths of binding and support regions.
}
\author{Peter Humburg}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{utilities}

\name{RLEBindScore-class}
\Rdversion{1.1}
\docType{class}
\alias{RLEBindScore-class}


\title{Run-length Encoded Binding Site Scores}
\description{This class provides a memory efficient representation of binding site scores.}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{BindScore(functionCall, score, pvalue, peaks, cutoff, nullDist, names, start, digits, compress=TRUE)}
or through calls to \code{\link{callBindingSites}}. 
}
\section{Slots}{
  \describe{
    \item{\code{functionCall}:}{Object of class \code{"call"} storing the function call used to initiate the analysis.}
    \item{\code{score}:}{Object of class \code{"list"}. The binding site score. One run-length encoded numeric vector per chromosome.}
    \item{\code{pvalue}:}{Object of class \code{"list"}. The (adjusted and run-length encoded) p-values corresponding to the scores in slot \code{score}.}
    \item{\code{peaks}:}{Object of class \code{"list"} giving the location of significant peaks in the binding site score. These correspond to the location of predicted binding sites.}
    \item{\code{cutoff}:}{Object of class \code{"numeric"} with entries \sQuote{pvalue} and \sQuote{score} giving the significance threshold used for peak calling in terms of p-value and score.}
    \item{\code{nullDist}:}{Object of class \code{"numeric"} providing the parameters of the null distribution used to determine p-values.}
    \item{\code{start}:}{Object of class \code{"integer"} indicating the index corresponding to the first entry in \code{score} (assumed to be the same for all chromosomes).}
  }
}
\section{Extends}{
Class \code{"\linkS4class{BindScore}"}, directly.
}
\section{Methods}{
  \describe{
    %\item{compress}{\code{signature(x = "RLEBindScore")}: ... }
    \item{decompress}{\code{signature(x = "RLEBindScore")}: conversion to \code{\linkS4class{BindScore}} object.}
	 }
}
\author{Peter Humburg}

\seealso{
\code{\linkS4class{BindScore}}, \code{\linkS4class{Rle}}
}
\examples{
showClass("RLEBindScore")

set.seed(1)

## determine binding site locations
b <- sample(1:1e6, 5000)

## sample read locations
fwd <- unlist(lapply(b, function(x) sample((x-83):(x-73), 20, replace=TRUE)))
rev <- unlist(lapply(b, function(x) sample((x+73):(x+83), 20, replace=TRUE)))

## add some background noise
fwd <- c(fwd, sample(1:(1e6-25), 50000))
rev <- c(rev, sample(25:1e6, 50000))

## create data.frame with read positions as input to strandPileup
reads <- data.frame(chromosome="chr1", position=c(fwd, rev), 
	length=25, strand=factor(rep(c("+", "-"), times=c(150000, 150000))))

## create object of class ReadCounts
readPile <- strandPileup(reads, chrLen=1e6, extend=1, plot=FALSE)

## predict binding site locations
## the artificial dataset is very small so predictions may not be very reliable
bindScore <- simpleNucCall(readPile, bind=147, support=20, plot=FALSE, compress=TRUE)

## number of binding sites found
length(bindScore)

## the first few predictions, by score
head(bindScore)

## score and p-value cut-off used
cutoff(bindScore)

}
\keyword{classes}

\name{callBindingSites-methods}
\docType{methods}
\alias{callBindingSites-methods}
\alias{callBindingSites}
\alias{callBindingSites,ANY-method}
\alias{callBindingSites,character-method}
\alias{callBindingSites,matrix-method}
\alias{callBindingSites,ReadCounts-method}
\title{Predict protein binding sites from high-throughput sequencing data}
\description{
 Methods for function \code{callBindingSites} in Package `ChIPseqR'. These methods are used to 
 identify protein binding sites from ChIP-seq data. 
}
\section{Methods}{
\describe{

\item{data = "ANY"}{Default method to handle all forms of input not explicitly handled by their own method. In particular this will be used for objects of class \code{\link[ShortRead:AlignedRead]{AlignedRead}} and \code{data.frame} but it will handle class for which a \code{\link{strandPileup}} method is available.}

\item{data = "character"}{Allows to use a file name referring to a file of mapped sequence reads as input.}

\item{data = "matrix"}{Uses a matrix of read counts (for a single chromosome) as input.}

\item{data = "ReadCounts"}{This methods implements the peak calling algorithm. Other methods will typically reformat their input and pass it on to this method.}
}}

\usage{
\S4method{callBindingSites}{ANY}(data, chrLen, plot=TRUE, verbose=TRUE, ..., plotTo)
\S4method{callBindingSites}{character}(data, type, minQual=70, ...)
\S4method{callBindingSites}{matrix}(data, chrName="chr", ...)
\S4method{callBindingSites}{ReadCounts}(data, bind, support, background, bgCutoff=0.9, supCutoff=0.9, 
fdr = 0.05, extend=1, tailCut=0.95, piLambda=0.5, adapt=FALSE, corSummary=median, compress = TRUE,
digits = 16, plot=TRUE, verbose=TRUE, ask=FALSE, plotTo, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{data}{Either an object containing information about mapped reads or a list. See below for details.}
  \item{bind}{Length of binding region to use (see Details).}
  \item{support}{Length of support region to use (see Details).}
  \item{background}{Length of background window. If this is missing it will be set to 10*(\code{bind}+2*\code{support}).}
  \item{chrLen}{Numeric vector indicating the length of all chromosomes. Only needed when 
  \code{data} is an \code{\link[ShortRead:AlignedRead]{AlignedRead}} object. \code{\link[ShortRead:readBfaToc]{readBfaToc}} 
  may be used to supply this information.}
  \item{bgCutoff}{Numeric value between 0.5 and 1. This determines how much estimates of the background read density are 
  allowed to vary for adjacent windows. Set to 1 to disable cutoff.}
  \item{supCutoff}{Numeric value between 0.5 and 1. This determines how much estimates of the support region read density are 
  allowed to vary for forward and reverse strand. Set to 1 to disable cutoff.}
  \item{fdr}{Target false discovery rate.}
  \item{extend}{Numeric value indicating how far mapped reads should be extended when calculating read counts.}
  \item{type}{Format of alignment file (see \code{\link[ShortRead:readAligned]{readAligned}} forr details).}
  \item{minQual}{Minimum alignment quality to use. All reads with lower alignment quality are discarded.}
  \item{tailCut}{Truncation point used to exclude outliers when estimating null distribution.}
  \item{chrName}{Name to use for the single chromosome.}
  \item{piLambda}{If \code{adapt=TRUE} this parameter is used to estimate the proportion of scores not related to binding sites.}
  \item{adapt}{Logical indicating whether an adaptive false discovery rate should be used. If this is \code{FALSE} (the default)
  the usual Benjamini-Hochberg procedure is used to control the FDR.}
  \item{corSummary}{Function used to summarise cross-correlation across chromosomes. See the Details section on 
  binding and support region. }
  \item{compress}{Logical indicating whether the return value should be compressed.}
  \item{digits}{Number of decimal places to retain for binding site score for compression.}
  \item{plot}{Logical. If \code{plot=TRUE} (the default) some diagnostic plots are produced during the analysis.}
  \item{verbose}{Logical. If \code{verbose=TRUE} (the default) status messages are printed to indicate progress.}
  \item{ask}{Logical. Setting this to \code{TRUE} causes the system to wait for user input before displaying a new plot.
  See \code{\link[grDevices:devAskNewPage]{devAskNewPage}}.}
  \item{plotTo}{Character string giving the name of a file that should be used to store plots generated during the analysis.
  If this is not missing a pdf file with the given name will be created.}
  \item{\dots}{Additional arguments. Most methods pass them on to the \code{ReadCounts} method.}
}
\details{
  The length of binding and support regions can either be given as a single value or as a range of 
  possible values (by providing the minimum and maximum). In the latter case the cross-correlation
  between read counts on forward and reverse strand will be used to determine a value within that range. 
  Note that this may lead  sub-optimal choices of binding and support region length.
}
\value{
  An object of class \code{\linkS4class{BindScore}} if \code{compress = FALSE}, otherwise an object
  of class \code{\linkS4class{RLEBindScore}}
}
\seealso{\code{\link{simpleNucCall}} for an interface with nucleosome specific defaults. This function uses 
\code{\link{strandPileup}}, \code{\link{startScore}}, \code{\link{getCutoff}} and \code{\link{pickPeak}}. See the 
help pages of these functions for additional detail on the individual steps involved. See \code{\link{getBindLen}} 
for details on the estimation of binding and support region length.}

\examples{
set.seed(1)

## determine binding site locations
b <- sample(1:1e6, 5000)

## sample read locations
fwd <- unlist(lapply(b, function(x) sample((x-83):(x-73), 20, replace=TRUE)))
rev <- unlist(lapply(b, function(x) sample((x+73):(x+83), 20, replace=TRUE)))

## add some background noise
fwd <- c(fwd, sample(1:(1e6-25), 50000))
rev <- c(rev, sample(25:1e6, 50000))

## create data.frame with read positions as input to strandPileup
reads <- data.frame(chromosome="chr1", position=c(fwd, rev), 
	length=25, strand=factor(rep(c("+", "-"), times=c(150000, 150000))))

## create object of class ReadCounts
readPile <- strandPileup(reads, chrLen=1e6, extend=1, plot=FALSE)

## predict binding site locations
## the artificial dataset is very small so predictions may not be very reliable
bindScore <- callBindingSites(readPile, bind=147, support=20, background=2000, plot=FALSE)
}

\keyword{methods}
\keyword{models}
\keyword{htest}

\name{exportBindSequence}
\Rdversion{1.1}
\alias{exportBindSequence}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Export sequence of predicted binding sites
}
\description{
Extracts sequence of predicted binding sites from reference genome and exports them in FASTA format.
}
\usage{
exportBindSequence(prediction, reference, bind, overlap = FALSE, file = "")
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{prediction}{
Object of class \code{\linkS4class{BindScore}}.
}
  \item{reference}{
Reference genome sequence (as \code{\linkS4class{XStringSet}} object). 
}
  \item{bind}{
Length of binding site to assume for sequence extraction. This may be missing in which case the value is 
derived from \code{'prediction'}.
}
  \item{overlap}{
Logical indicating whether overlapping predictions should be allowed.
}
  \item{file}{
Name of output file.
}
}

\value{
An \code{\linkS4class{XStringViews}} object containing the sequences. If a file name is provided this is returned
invisibly.
}
\references{
Package \code{Biostrings}
}
\author{
Peter Humburg
}


\seealso{
\code{\linkS4class{XStringViews}}, \code{\linkS4class{XStringSet}}, \code{\linkS4class{BindScore}}
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{utilities}

\name{startScore}
\alias{startScore}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Score potential protein binding sites}
\description{
  For each position in the genome this function computes a score indicating the
  likelihood that a protein binding site starts at that position.
}
\usage{
startScore(data, b, support, background, bgCutoff, supCutoff)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{data}{A two column matrix with read counts. The two columns correspond to reads on the 
  forward and reverse strand respectively.}
  \item{b}{Length of binding region.}
  \item{support}{Length of support region.}
  \item{background}{Length of background window.}
  \item{bgCutoff}{Cutoff for the change in read rates between adjacent windows (see Details).}
  \item{supCutoff}{Cutoff for the change in read rates between support regions on forward and 
  reverse strand (see Details).}
}
\details{
  Robust estimates of read rates in background windows and support regions are obtained by limiting the
  difference between related estimates. Consider a forward support region of length 10 containing 20 reads.
  The maximum likelihood estimate for the rate parameter of the (assumed) underlying Poisson distribution is
  \eqn{\hat{\lambda} = \frac{20}{10} = 2}{lambda_hat = 20/10 = 2}. If there are 50 reads in the reverse
  support region a robust estimate of the rate parameter is obtained as 
  \code{max(50/10, qpois(supCutoff, lambda=lambda_hat))}  
}
\value{
  Numeric vector with binding site scores.
}
\note{
Instead of calling this function directly use \code{\link{callBindingSites}}.
}

\author{Peter Humburg}

\seealso{\code{\link{callBindingSites}}}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{models}

\name{plot,ReadCounts,missing-method}
\alias{plot,ReadCounts,missing-method}
\alias{plot,RLEReadCounts,missing-method}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Diagnostic Plots for Read Counts
}
\description{
Produces plots to assess the distribution of reads, either for an entire chromosome or within
a (small) window.
}
\usage{
\S4method{plot}{ReadCounts,missing}(x, chr, center, score, width=2000, type=c("hilbert", "window"), ...)
\S4method{plot}{RLEReadCounts,missing}(x, chr, center, score, width=2000, type=c("hilbert", "window"), ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
	Object of class \code{\linkS4class{ReadCounts}} or \code{\linkS4class{RLEReadCounts}}. 
}
  \item{chr}{
	Index or name of chromosome for which read counts should be plotted.
}
  \item{center}{
	For type \sQuote{window}, the center coordinate of the window to plot.  
}
  \item{score}{
  	For type \sQuote{window}, an object of type \code{\linkS4class{BindScore}} 
  	(or \code{\linkS4class{BindScore}}) that should be used to include information
  	about the score and predicted binding sites into the plot.
}
  \item{width}{
	For type \sQuote{window}, the width of the window.  
}
  \item{type}{
	Character string indicating the type of plot that should be produced (see details).  
}
  \item{\dots}{
	Further arguments (see details).
}
}
\details{
Type \sQuote{window} produces a plot that shows read counts as vertical bars. If \code{score}
is not missing, it is used to plot the score and predicted binding sites (if any) as well. 
Any additional arguments are passed on to \code{\link{.plotWindow}}.

Type \sQuote{hilbert} produces a Hilbert curve plot of read counts for an entire chromosome.
Additional arguments are passed on to  \code{\link{.plotReads}}.
}
\value{
Called for its side effect.
}

\author{
Peter Humburg
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link[HilbertVis:hilbertImage]{hilbertImage}}
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{hplot}
